/**
* @module vue-mdc-adaptergrid-list 0.18.1
* @exports VueMDCGridList
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"@material/tabs":"^0.38.0","material-components-web":"^0.38.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.VueMDCGridList=e()}(this,function(){"use strict";var t={components:{CustomElement:{functional:!0,render:function(t,e){return t(e.props.is||e.props.tag||"div",e.data,e.children)}}}},e=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")},i=function(){function t(t,e){for(var i=0;i<e.length;i++){var n=e[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(t,n.key,n)}}return function(e,i,n){return i&&t(e.prototype,i),n&&t(e,n),e}}(),n=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var i=arguments[e];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(t[n]=i[n])}return t},a=function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):t.__proto__=e)},r=function(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e},s={props:{event:String,"event-target":Object,"event-args":Array},methods:{dispatchEvent:function(t){if(t&&this.$emit(t.type,t),this.event){var e=this.eventTarget||this.$root,i=this.eventArgs||[];e.$emit.apply(e,[this.event].concat(function(t){if(Array.isArray(t)){for(var e=0,i=Array(t.length);e<t.length;e++)i[e]=t[e];return i}return Array.from(t)}(i)))}}},computed:{listeners:function(){var t=this;return n({},this.$listeners,{click:function(e){return t.dispatchEvent(e)}})}}},o=(Math.floor(Math.random()*Math.floor(268435456)).toString(),function(){function t(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};e(this,t),this.adapter_=i}return i(t,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),i(t,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),t}()),c=(function(){function t(i){var n=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;e(this,t),this.root_=i;for(var a=arguments.length,r=Array(a>2?a-2:0),s=2;s<a;s++)r[s-2]=arguments[s];this.initialize.apply(this,r),this.foundation_=void 0===n?this.getDefaultFoundation():n,this.foundation_.init(),this.initialSyncWithDOM()}i(t,null,[{key:"attachTo",value:function(e){return new t(e,new o)}}]),i(t,[{key:"initialize",value:function(){}},{key:"getDefaultFoundation",value:function(){throw new Error("Subclasses must override getDefaultFoundation to return a properly configured foundation class")}},{key:"initialSyncWithDOM",value:function(){}},{key:"destroy",value:function(){this.foundation_.destroy()}},{key:"listen",value:function(t,e){this.root_.addEventListener(t,e)}},{key:"unlisten",value:function(t,e){this.root_.removeEventListener(t,e)}},{key:"emit",value:function(t,e){var i=arguments.length>2&&void 0!==arguments[2]&&arguments[2],n=void 0;"function"==typeof CustomEvent?n=new CustomEvent(t,{detail:e,bubbles:i}):(n=document.createEvent("CustomEvent")).initCustomEvent(t,i,!1,e),this.root_.dispatchEvent(n)}}])}(),{TILES_SELECTOR:".mdc-grid-list__tiles",TILE_SELECTOR:".mdc-grid-tile"}),u=function(t){function s(t){e(this,s);var i=r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n(s.defaultAdapter,t)));return i.resizeHandler_=function(){return i.alignCenter()},i.resizeFrame_=0,i}return a(s,o),i(s,null,[{key:"strings",get:function(){return c}},{key:"defaultAdapter",get:function(){return{getOffsetWidth:function(){return 0},getNumberOfTiles:function(){return 0},getOffsetWidthForTileAtIndex:function(){return 0},setStyleForTilesElement:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){}}}}]),i(s,[{key:"init",value:function(){this.alignCenter(),this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"destroy",value:function(){this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"alignCenter",value:function(){var t=this;0!==this.resizeFrame_&&cancelAnimationFrame(this.resizeFrame_),this.resizeFrame_=requestAnimationFrame(function(){t.alignCenter_(),t.resizeFrame_=0})}},{key:"alignCenter_",value:function(){if(0!=this.adapter_.getNumberOfTiles()){var t=this.adapter_.getOffsetWidth(),e=this.adapter_.getOffsetWidthForTileAtIndex(0),i=e*Math.floor(t/e);this.adapter_.setStyleForTilesElement("width",i+"px")}}}]),s}(),d={name:"mdc-grid-list",props:{width:[String,Number],ratio:String,"narrow-gutter":Boolean,"header-caption":Boolean,"icon-align-start":Boolean,"icon-align-end":Boolean,"with-support-text":Boolean,interactive:Boolean},provide:function(){return{mdcGrid:this}},computed:{classes:function(){var t={};return t["mdc-grid-list--tile-gutter-1"]=this.narrowGutter,t["mdc-grid-list--header-caption"]=this.headerCaption,t["mdc-grid-list--tile-aspect-"+this.ratio]=this.ratio,t["mdc-grid-list--with-icon-align-start"]=this.iconAlignStart,t["mdc-grid-list--with-icon-align-end"]=this.iconAlignEnd,t["mdc-grid-list--twoline-caption"]=this.withSupportText,t["mdc-grid-list--non-interactive"]=!this.interactive,t},styles:function(){return{"--mdc-grid-list-tile-width":(this.width||200)+"px"}}},mounted:function(){var t=this;this.foundation=new u({getOffsetWidth:function(){return t.$el.offsetWidth},getNumberOfTiles:function(){return t.$el.querySelectorAll(u.strings.TILE_SELECTOR).length},getOffsetWidthForTileAtIndex:function(e){return t.$el.querySelectorAll(u.strings.TILE_SELECTOR)[e].offsetWidth},setStyleForTilesElement:function(e,i){t.$el.querySelector(u.strings.TILES_SELECTOR).style[e]=i},registerResizeHandler:function(t){window.addEventListener("resize",t)},deregisterResizeHandler:function(t){window.removeEventListener("resize",t)}}),this.foundation.init()},beforeDestroy:function(){this.foundation.destroy()}},l=function(){var t=this.$createElement,e=this._self._c||t;return e("div",{staticClass:"mdc-grid-list"},[e("ul",{staticClass:"mdc-grid-list__tiles",class:this.classes,style:this.styles},[this._t("default")],2)])};l._withStripped=!0;var f=function(t,e,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/grid-list/mdc-grid-list.vue",c.render||(c.render=t.render,c.staticRenderFns=t.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:l,staticRenderFns:[]},0,d,void 0,!1),v=(function(){function t(){e(this,t)}i(t,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(t){}},{key:"removeClass",value:function(t){}},{key:"containsEventTarget",value:function(t){}},{key:"registerInteractionHandler",value:function(t,e){}},{key:"deregisterInteractionHandler",value:function(t,e){}},{key:"registerDocumentInteractionHandler",value:function(t,e){}},{key:"deregisterDocumentInteractionHandler",value:function(t,e){}},{key:"registerResizeHandler",value:function(t){}},{key:"deregisterResizeHandler",value:function(t){}},{key:"updateCssVariable",value:function(t,e){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),h={VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},p={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:225,FG_DEACTIVATION_MS:150,TAP_DELAY_MS:300},_=void 0,m=void 0;
/**
     * @license
     * Copyright 2016 Google Inc. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */function g(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window,e=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===m||e){var i=!1;try{t.document.addEventListener("test",null,{get passive(){i=!0}})}catch(t){}m=i}return!!m&&{passive:!0}}
/**
     * @license
     * Copyright 2016 Google Inc. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
var y=["touchstart","pointerdown","mousedown","keydown"],A=["touchend","pointerup","mouseup"],C=[],E=function(t){function s(t){e(this,s);var i=r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n(s.defaultAdapter,t)));return i.layoutFrame_=0,i.frame_={width:0,height:0},i.activationState_=i.defaultActivationState_(),i.initialSize_=0,i.maxRadius_=0,i.activateHandler_=function(t){return i.activate_(t)},i.deactivateHandler_=function(t){return i.deactivate_(t)},i.focusHandler_=function(){return i.handleFocus()},i.blurHandler_=function(){return i.handleBlur()},i.resizeHandler_=function(){return i.layout()},i.unboundedCoords_={left:0,top:0},i.fgScale_=0,i.activationTimer_=0,i.fgDeactivationRemovalTimer_=0,i.activationAnimationHasEnded_=!1,i.activationTimerCallback_=function(){i.activationAnimationHasEnded_=!0,i.runDeactivationUXLogicIfReady_()},i.previousActivationEvent_=null,i}return a(s,o),i(s,null,[{key:"cssClasses",get:function(){return v}},{key:"strings",get:function(){return h}},{key:"numbers",get:function(){return p}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},containsEventTarget:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerDocumentInteractionHandler:function(){},deregisterDocumentInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),i(s,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var t=this;if(this.isSupported_()){this.registerRootHandlers_();var e=s.cssClasses,i=e.ROOT,n=e.UNBOUNDED;requestAnimationFrame(function(){t.adapter_.addClass(i),t.adapter_.isUnbounded()&&(t.adapter_.addClass(n),t.layoutInternal_())})}}},{key:"destroy",value:function(){var t=this;if(this.isSupported_()){if(this.activationTimer_){clearTimeout(this.activationTimer_),this.activationTimer_=0;var e=s.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(e)}this.deregisterRootHandlers_(),this.deregisterDeactivationHandlers_();var i=s.cssClasses,n=i.ROOT,a=i.UNBOUNDED;requestAnimationFrame(function(){t.adapter_.removeClass(n),t.adapter_.removeClass(a),t.removeCssVars_()})}}},{key:"registerRootHandlers_",value:function(){var t=this;y.forEach(function(e){t.adapter_.registerInteractionHandler(e,t.activateHandler_)}),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"registerDeactivationHandlers_",value:function(t){var e=this;"keydown"===t.type?this.adapter_.registerInteractionHandler("keyup",this.deactivateHandler_):A.forEach(function(t){e.adapter_.registerDocumentInteractionHandler(t,e.deactivateHandler_)})}},{key:"deregisterRootHandlers_",value:function(){var t=this;y.forEach(function(e){t.adapter_.deregisterInteractionHandler(e,t.activateHandler_)}),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"deregisterDeactivationHandlers_",value:function(){var t=this;this.adapter_.deregisterInteractionHandler("keyup",this.deactivateHandler_),A.forEach(function(e){t.adapter_.deregisterDocumentInteractionHandler(e,t.deactivateHandler_)})}},{key:"removeCssVars_",value:function(){var t=this,e=s.strings;Object.keys(e).forEach(function(i){0===i.indexOf("VAR_")&&t.adapter_.updateCssVariable(e[i],null)})}},{key:"activate_",value:function(t){var e=this;if(!this.adapter_.isSurfaceDisabled()){var i=this.activationState_;if(!i.isActivated){var n=this.previousActivationEvent_;if(!(n&&t&&n.type!==t.type))i.isActivated=!0,i.isProgrammatic=null===t,i.activationEvent=t,i.wasActivatedByPointer=!i.isProgrammatic&&("mousedown"===t.type||"touchstart"===t.type||"pointerdown"===t.type),t&&C.length>0&&C.some(function(t){return e.adapter_.containsEventTarget(t)})?this.resetActivationState_():(t&&(C.push(t.target),this.registerDeactivationHandlers_(t)),i.wasElementMadeActive=this.checkElementMadeActive_(t),i.wasElementMadeActive&&this.animateActivation_(),requestAnimationFrame(function(){C=[],i.wasElementMadeActive||" "!==t.key&&32!==t.keyCode||(i.wasElementMadeActive=e.checkElementMadeActive_(t),i.wasElementMadeActive&&e.animateActivation_()),i.wasElementMadeActive||(e.activationState_=e.defaultActivationState_())}))}}}},{key:"checkElementMadeActive_",value:function(t){return!t||"keydown"!==t.type||this.adapter_.isSurfaceActive()}},{key:"activate",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(t)}},{key:"animateActivation_",value:function(){var t=this,e=s.strings,i=e.VAR_FG_TRANSLATE_START,n=e.VAR_FG_TRANSLATE_END,a=s.cssClasses,r=a.FG_DEACTIVATION,o=a.FG_ACTIVATION,c=s.numbers.DEACTIVATION_TIMEOUT_MS;this.layoutInternal_();var u="",d="";if(!this.adapter_.isUnbounded()){var l=this.getFgTranslationCoordinates_(),f=l.startPoint,v=l.endPoint;u=f.x+"px, "+f.y+"px",d=v.x+"px, "+v.y+"px"}this.adapter_.updateCssVariable(i,u),this.adapter_.updateCssVariable(n,d),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(r),this.adapter_.computeBoundingRect(),this.adapter_.addClass(o),this.activationTimer_=setTimeout(function(){return t.activationTimerCallback_()},c)}},{key:"getFgTranslationCoordinates_",value:function(){var t,e,i,n,a,r,s,o,c,u=this.activationState_,d=u.activationEvent,l=void 0;return u.wasActivatedByPointer?(t=d,e=this.adapter_.getWindowPageOffset(),i=this.adapter_.computeBoundingRect(),n=e.x,a=e.y,r=n+i.left,s=a+i.top,o=void 0,c=void 0,"touchstart"===t.type?(o=t.changedTouches[0].pageX-r,c=t.changedTouches[0].pageY-s):(o=t.pageX-r,c=t.pageY-s),l={x:o,y:c}):l={x:this.frame_.width/2,y:this.frame_.height/2},{startPoint:l={x:l.x-this.initialSize_/2,y:l.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var t=this,e=s.cssClasses.FG_DEACTIVATION,i=this.activationState_,n=i.hasDeactivationUXRun,a=i.isActivated;(n||!a)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(e),this.fgDeactivationRemovalTimer_=setTimeout(function(){t.adapter_.removeClass(e)},p.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var t=s.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(t),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"resetActivationState_",value:function(){var t=this;this.previousActivationEvent_=this.activationState_.activationEvent,this.activationState_=this.defaultActivationState_(),setTimeout(function(){return t.previousActivationEvent_=null},s.numbers.TAP_DELAY_MS)}},{key:"deactivate_",value:function(t){var e=this,i=this.activationState_;if(i.isActivated){var a=n({},i);if(i.isProgrammatic){requestAnimationFrame(function(){return e.animateDeactivation_(null,a)}),this.resetActivationState_()}else this.deregisterDeactivationHandlers_(),requestAnimationFrame(function(){e.activationState_.hasDeactivationUXRun=!0,e.animateDeactivation_(t,a),e.resetActivationState_()})}}},{key:"deactivate",value:function(){var t=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(t)}},{key:"animateDeactivation_",value:function(t,e){var i=e.wasActivatedByPointer,n=e.wasElementMadeActive;(i||n)&&this.runDeactivationUXLogicIfReady_()}},{key:"layout",value:function(){var t=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){t.layoutInternal_(),t.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){var t=this;this.frame_=this.adapter_.computeBoundingRect();var e=Math.max(this.frame_.height,this.frame_.width);this.maxRadius_=this.adapter_.isUnbounded()?e:Math.sqrt(Math.pow(t.frame_.width,2)+Math.pow(t.frame_.height,2))+s.numbers.PADDING,this.initialSize_=e*s.numbers.INITIAL_ORIGIN_SCALE,this.fgScale_=this.maxRadius_/this.initialSize_,this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var t=s.strings,e=t.VAR_FG_SIZE,i=t.VAR_LEFT,n=t.VAR_TOP,a=t.VAR_FG_SCALE;this.adapter_.updateCssVariable(e,this.initialSize_+"px"),this.adapter_.updateCssVariable(a,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(i,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(n,this.unboundedCoords_.top+"px"))}},{key:"setUnbounded",value:function(t){var e=s.cssClasses.UNBOUNDED;t?this.adapter_.addClass(e):this.adapter_.removeClass(e)}},{key:"handleFocus",value:function(){var t=this;requestAnimationFrame(function(){return t.adapter_.addClass(s.cssClasses.BG_FOCUSED)})}},{key:"handleBlur",value:function(){var t=this;requestAnimationFrame(function(){return t.adapter_.removeClass(s.cssClasses.BG_FOCUSED)})}}]),s}(),S=function(t){function s(t,i){return e(this,s),r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n({browserSupportsCssVars:function(){return function(t){var e=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=_;if("boolean"==typeof _&&!e)return i;if(t.CSS&&"function"==typeof t.CSS.supports){var n=t.CSS.supports("--css-vars","yes"),a=t.CSS.supports("(--css-vars: yes)")&&t.CSS.supports("color","#00000000");return i=!(!n&&!a||function(t){var e=t.document,i=e.createElement("div");i.className="mdc-ripple-surface--test-edge-var-bug",e.body.appendChild(i);var n=t.getComputedStyle(i),a=null!==n&&"solid"===n.borderTopStyle;return i.remove(),a}(t)),e||(_=i),i}}(window)},isUnbounded:function(){return!1},isSurfaceActive:function(){return t.$el[s.MATCHES](":active")},isSurfaceDisabled:function(){return t.disabled},addClass:function(e){t.$set(t.classes,e,!0)},removeClass:function(e){t.$delete(t.classes,e)},containsEventTarget:function(e){return t.$el.contains(e)},registerInteractionHandler:function(e,i){t.$el.addEventListener(e,i,g())},deregisterInteractionHandler:function(e,i){t.$el.removeEventListener(e,i,g())},registerDocumentInteractionHandler:function(t,e){return document.documentElement.addEventListener(t,e,g())},deregisterDocumentInteractionHandler:function(t,e){return document.documentElement.removeEventListener(t,e,g())},registerResizeHandler:function(t){return window.addEventListener("resize",t)},deregisterResizeHandler:function(t){return window.removeEventListener("resize",t)},updateCssVariable:function(e,i){t.$set(t.styles,e,i)},computeBoundingRect:function(){return t.$el.getBoundingClientRect()},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}}},i)))}return a(s,E),i(s,null,[{key:"isSurfaceActive",value:function(t){return t[s.MATCHES](":active")}},{key:"MATCHES",get:function(){return s._matches||(s._matches=(t=HTMLElement.prototype,["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(e){return e in t}).pop()));var t}}]),s}(),T={name:"mdc-ripple",mixins:[t,{data:function(){return{classes:{},styles:{}}},mounted:function(){this.ripple=new S(this),this.ripple.init()},beforeDestroy:function(){this.ripple.destroy()}}],props:{tag:String}},b=function(){var t=this.$createElement;return(this._self._c||t)("custom-element",{staticClass:"mdc-ripple",attrs:{tag:this.tag,classes:this.classes,styles:this.styles}},[this._t("default")],2)};b._withStripped=!0;!function(t,e,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/ripple/mdc-ripple.vue",c.render||(c.render=t.render,c.staticRenderFns=t.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n}({render:b,staticRenderFns:[]},0,T,void 0,!1);var k={name:"mdc-grid-tile",inject:["mdcGrid"],mixins:[s],props:{src:String,cover:Boolean,icon:String,title:String,"support-text":String,selected:Boolean,activated:Boolean},data:function(){return{classes:{},styles:{}}},computed:{clickListener:function(){var t=this;return{click:function(e){return t.dispatchEvent(e)}}},itemClasses:function(){return{"mdc-grid-tile--selected":this.selected,"mdc-grid-tile--activated":this.activated}},isInteractive:function(){return this.mdcGrid&&this.mdcGrid.interactive},hasStartDetail:function(){return this.startIcon||this.$slots["start-detail"]},hasEndDetail:function(){return this.endIcon||this.$slots["end-detail"]}},watch:{isInteractive:function(t){t?this.addRipple():this.removeRipple()}},mounted:function(){this.isInteractive&&this.addRipple()},beforeDestroy:function(){this.removeRipple()},methods:{addRipple:function(){if(!this.ripple){var t=new S(this);t.init(),this.ripple=t}},removeRipple:function(){if(this.ripple){var t=this.ripple;this.ripple=null,t.destroy()}}}},w=function(){var t=this,e=t.$createElement,i=t._self._c||e;return i("li",t._g({staticClass:"mdc-grid-tile",class:[t.classes,t.itemClasses],style:t.styles,attrs:{tabindex:t.isInteractive?"0":void 0}},t.isInteractive?t.listeners:t.clickListener),[t.cover?i("div",{staticClass:"mdc-grid-tile__primary"},[i("div",{staticClass:"mdc-grid-tile__primary-content",style:{backgroundImage:"url("+t.src+")"}})]):i("div",{staticClass:"mdc-grid-tile__primary"},[i("img",{staticClass:"mdc-grid-tile__primary-content",attrs:{src:t.src}})]),t._v(" "),t.title||t.supportText?i("span",{staticClass:"mdc-grid-tile__secondary"},[t.icon?i("i",{staticClass:"mdc-grid-tile__icon material-icons"},[t._v(t._s(t.icon))]):t._e(),t._v(" "),t.title?i("span",{staticClass:"mdc-grid-tile__title"},[t._v(t._s(t.title))]):t._e(),t._v(" "),t.supportText?i("span",{staticClass:"mdc-grid-tile__support-text"},[t._v(t._s(t.supportText))]):t._e()]):t._e()])};w._withStripped=!0;var I,R=function(t,e,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/grid-list/mdc-grid-tile.vue",c.render||(c.render=t.render,c.staticRenderFns=t.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:w,staticRenderFns:[]},0,k,void 0,!1),H={version:"0.18.1",install:function(t){for(var e in I){var i=I[e];t.component(i.name,i)}},components:I={mdcGridList:f,mdcGridTile:R}};return function(t){var e=null;"undefined"!=typeof window?e=window.Vue:"undefined"!=typeof global&&(e=global.Vue),e&&e.use(t)}(H),H});
//# sourceMappingURL=grid-list.min.js.map
