/**
* @module vue-mdc-adapterlist 0.18.1
* @exports VueMDCList
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"@material/tabs":"^0.38.0","material-components-web":"^0.38.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueMDCList=t()}(this,function(){"use strict";var e={components:{CustomElement:{functional:!0,render:function(e,t){return e(t.props.is||t.props.tag||"div",t.data,t.children)}}}},t=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},i=function(){function e(e,t){for(var i=0;i<t.length;i++){var n=t[i];n.enumerable=n.enumerable||!1,n.configurable=!0,"value"in n&&(n.writable=!0),Object.defineProperty(e,n.key,n)}}return function(t,i,n){return i&&e(t.prototype,i),n&&e(t,n),t}}(),n=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var i=arguments[t];for(var n in i)Object.prototype.hasOwnProperty.call(i,n)&&(e[n]=i[n])}return e},a=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},r=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},s=(Math.floor(Math.random()*Math.floor(268435456)).toString(),{name:"mdc-list",props:{dense:Boolean,avatarList:Boolean,twoLine:Boolean,bordered:Boolean,interactive:Boolean},provide:function(){return{mdcList:this}},computed:{classes:function(){return{"mdc-list--dense":this.dense,"mdc-list--avatar-list":this.avatarList,"mdc-list--two-line":this.twoLine,"mdc-list--bordered":this.bordered,"mdc-list--non-interactive":!this.interactive}}}}),o=function(){var e=this.$createElement;return(this._self._c||e)("ul",{staticClass:"mdc-list",class:this.classes},[this._t("default")],2)};o._withStripped=!0;var c=function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/list/mdc-list.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:o,staticRenderFns:[]},0,s,void 0,!1),d=function(){function e(){var i=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};t(this,e),this.adapter_=i}return i(e,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),i(e,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),e}(),u=(function(){function e(){t(this,e)}i(e,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"containsEventTarget",value:function(e){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}},{key:"registerDocumentInteractionHandler",value:function(e,t){}},{key:"deregisterDocumentInteractionHandler",value:function(e,t){}},{key:"registerResizeHandler",value:function(e){}},{key:"deregisterResizeHandler",value:function(e){}},{key:"updateCssVariable",value:function(e,t){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),l={VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},v={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:225,FG_DEACTIVATION_MS:150,TAP_DELAY_MS:300},p=void 0,f=void 0;
/**
     * @license
     * Copyright 2016 Google Inc.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *   http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */function _(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window,t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===f||t){var i=!1;try{e.document.addEventListener("test",null,{get passive(){i=!0}})}catch(e){}f=i}return!!f&&{passive:!0}}
/**
     * @license
     * Copyright 2016 Google Inc. All Rights Reserved.
     *
     * Licensed under the Apache License, Version 2.0 (the "License");
     * you may not use this file except in compliance with the License.
     * You may obtain a copy of the License at
     *
     *      http://www.apache.org/licenses/LICENSE-2.0
     *
     * Unless required by applicable law or agreed to in writing, software
     * distributed under the License is distributed on an "AS IS" BASIS,
     * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
     * See the License for the specific language governing permissions and
     * limitations under the License.
     */
var h=["touchstart","pointerdown","mousedown","keydown"],m=["touchend","pointerup","mouseup"],g=[],y=function(e){function s(e){t(this,s);var i=r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n(s.defaultAdapter,e)));return i.layoutFrame_=0,i.frame_={width:0,height:0},i.activationState_=i.defaultActivationState_(),i.initialSize_=0,i.maxRadius_=0,i.activateHandler_=function(e){return i.activate_(e)},i.deactivateHandler_=function(e){return i.deactivate_(e)},i.focusHandler_=function(){return i.handleFocus()},i.blurHandler_=function(){return i.handleBlur()},i.resizeHandler_=function(){return i.layout()},i.unboundedCoords_={left:0,top:0},i.fgScale_=0,i.activationTimer_=0,i.fgDeactivationRemovalTimer_=0,i.activationAnimationHasEnded_=!1,i.activationTimerCallback_=function(){i.activationAnimationHasEnded_=!0,i.runDeactivationUXLogicIfReady_()},i.previousActivationEvent_=null,i}return a(s,d),i(s,null,[{key:"cssClasses",get:function(){return u}},{key:"strings",get:function(){return l}},{key:"numbers",get:function(){return v}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},containsEventTarget:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerDocumentInteractionHandler:function(){},deregisterDocumentInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),i(s,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var e=this;if(this.isSupported_()){this.registerRootHandlers_();var t=s.cssClasses,i=t.ROOT,n=t.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.addClass(i),e.adapter_.isUnbounded()&&(e.adapter_.addClass(n),e.layoutInternal_())})}}},{key:"destroy",value:function(){var e=this;if(this.isSupported_()){if(this.activationTimer_){clearTimeout(this.activationTimer_),this.activationTimer_=0;var t=s.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(t)}this.deregisterRootHandlers_(),this.deregisterDeactivationHandlers_();var i=s.cssClasses,n=i.ROOT,a=i.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.removeClass(n),e.adapter_.removeClass(a),e.removeCssVars_()})}}},{key:"registerRootHandlers_",value:function(){var e=this;h.forEach(function(t){e.adapter_.registerInteractionHandler(t,e.activateHandler_)}),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"registerDeactivationHandlers_",value:function(e){var t=this;"keydown"===e.type?this.adapter_.registerInteractionHandler("keyup",this.deactivateHandler_):m.forEach(function(e){t.adapter_.registerDocumentInteractionHandler(e,t.deactivateHandler_)})}},{key:"deregisterRootHandlers_",value:function(){var e=this;h.forEach(function(t){e.adapter_.deregisterInteractionHandler(t,e.activateHandler_)}),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"deregisterDeactivationHandlers_",value:function(){var e=this;this.adapter_.deregisterInteractionHandler("keyup",this.deactivateHandler_),m.forEach(function(t){e.adapter_.deregisterDocumentInteractionHandler(t,e.deactivateHandler_)})}},{key:"removeCssVars_",value:function(){var e=this,t=s.strings;Object.keys(t).forEach(function(i){0===i.indexOf("VAR_")&&e.adapter_.updateCssVariable(t[i],null)})}},{key:"activate_",value:function(e){var t=this;if(!this.adapter_.isSurfaceDisabled()){var i=this.activationState_;if(!i.isActivated){var n=this.previousActivationEvent_;if(!(n&&e&&n.type!==e.type))i.isActivated=!0,i.isProgrammatic=null===e,i.activationEvent=e,i.wasActivatedByPointer=!i.isProgrammatic&&("mousedown"===e.type||"touchstart"===e.type||"pointerdown"===e.type),e&&g.length>0&&g.some(function(e){return t.adapter_.containsEventTarget(e)})?this.resetActivationState_():(e&&(g.push(e.target),this.registerDeactivationHandlers_(e)),i.wasElementMadeActive=this.checkElementMadeActive_(e),i.wasElementMadeActive&&this.animateActivation_(),requestAnimationFrame(function(){g=[],i.wasElementMadeActive||" "!==e.key&&32!==e.keyCode||(i.wasElementMadeActive=t.checkElementMadeActive_(e),i.wasElementMadeActive&&t.animateActivation_()),i.wasElementMadeActive||(t.activationState_=t.defaultActivationState_())}))}}}},{key:"checkElementMadeActive_",value:function(e){return!e||"keydown"!==e.type||this.adapter_.isSurfaceActive()}},{key:"activate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(e)}},{key:"animateActivation_",value:function(){var e=this,t=s.strings,i=t.VAR_FG_TRANSLATE_START,n=t.VAR_FG_TRANSLATE_END,a=s.cssClasses,r=a.FG_DEACTIVATION,o=a.FG_ACTIVATION,c=s.numbers.DEACTIVATION_TIMEOUT_MS;this.layoutInternal_();var d="",u="";if(!this.adapter_.isUnbounded()){var l=this.getFgTranslationCoordinates_(),v=l.startPoint,p=l.endPoint;d=v.x+"px, "+v.y+"px",u=p.x+"px, "+p.y+"px"}this.adapter_.updateCssVariable(i,d),this.adapter_.updateCssVariable(n,u),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(r),this.adapter_.computeBoundingRect(),this.adapter_.addClass(o),this.activationTimer_=setTimeout(function(){return e.activationTimerCallback_()},c)}},{key:"getFgTranslationCoordinates_",value:function(){var e,t,i,n,a,r,s,o,c,d=this.activationState_,u=d.activationEvent,l=void 0;return d.wasActivatedByPointer?(e=u,t=this.adapter_.getWindowPageOffset(),i=this.adapter_.computeBoundingRect(),n=t.x,a=t.y,r=n+i.left,s=a+i.top,o=void 0,c=void 0,"touchstart"===e.type?(o=e.changedTouches[0].pageX-r,c=e.changedTouches[0].pageY-s):(o=e.pageX-r,c=e.pageY-s),l={x:o,y:c}):l={x:this.frame_.width/2,y:this.frame_.height/2},{startPoint:l={x:l.x-this.initialSize_/2,y:l.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var e=this,t=s.cssClasses.FG_DEACTIVATION,i=this.activationState_,n=i.hasDeactivationUXRun,a=i.isActivated;(n||!a)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(t),this.fgDeactivationRemovalTimer_=setTimeout(function(){e.adapter_.removeClass(t)},v.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var e=s.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(e),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"resetActivationState_",value:function(){var e=this;this.previousActivationEvent_=this.activationState_.activationEvent,this.activationState_=this.defaultActivationState_(),setTimeout(function(){return e.previousActivationEvent_=null},s.numbers.TAP_DELAY_MS)}},{key:"deactivate_",value:function(e){var t=this,i=this.activationState_;if(i.isActivated){var a=n({},i);if(i.isProgrammatic){requestAnimationFrame(function(){return t.animateDeactivation_(null,a)}),this.resetActivationState_()}else this.deregisterDeactivationHandlers_(),requestAnimationFrame(function(){t.activationState_.hasDeactivationUXRun=!0,t.animateDeactivation_(e,a),t.resetActivationState_()})}}},{key:"deactivate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(e)}},{key:"animateDeactivation_",value:function(e,t){var i=t.wasActivatedByPointer,n=t.wasElementMadeActive;(i||n)&&this.runDeactivationUXLogicIfReady_()}},{key:"layout",value:function(){var e=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){e.layoutInternal_(),e.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){var e=this;this.frame_=this.adapter_.computeBoundingRect();var t=Math.max(this.frame_.height,this.frame_.width);this.maxRadius_=this.adapter_.isUnbounded()?t:Math.sqrt(Math.pow(e.frame_.width,2)+Math.pow(e.frame_.height,2))+s.numbers.PADDING,this.initialSize_=t*s.numbers.INITIAL_ORIGIN_SCALE,this.fgScale_=this.maxRadius_/this.initialSize_,this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var e=s.strings,t=e.VAR_FG_SIZE,i=e.VAR_LEFT,n=e.VAR_TOP,a=e.VAR_FG_SCALE;this.adapter_.updateCssVariable(t,this.initialSize_+"px"),this.adapter_.updateCssVariable(a,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(i,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(n,this.unboundedCoords_.top+"px"))}},{key:"setUnbounded",value:function(e){var t=s.cssClasses.UNBOUNDED;e?this.adapter_.addClass(t):this.adapter_.removeClass(t)}},{key:"handleFocus",value:function(){var e=this;requestAnimationFrame(function(){return e.adapter_.addClass(s.cssClasses.BG_FOCUSED)})}},{key:"handleBlur",value:function(){var e=this;requestAnimationFrame(function(){return e.adapter_.removeClass(s.cssClasses.BG_FOCUSED)})}}]),s}(),A=function(e){function s(e,i){return t(this,s),r(this,(s.__proto__||Object.getPrototypeOf(s)).call(this,n({browserSupportsCssVars:function(){return function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],i=p;if("boolean"==typeof p&&!t)return i;if(e.CSS&&"function"==typeof e.CSS.supports){var n=e.CSS.supports("--css-vars","yes"),a=e.CSS.supports("(--css-vars: yes)")&&e.CSS.supports("color","#00000000");return i=!(!n&&!a||function(e){var t=e.document,i=t.createElement("div");i.className="mdc-ripple-surface--test-edge-var-bug",t.body.appendChild(i);var n=e.getComputedStyle(i),a=null!==n&&"solid"===n.borderTopStyle;return i.remove(),a}(e)),t||(p=i),i}}(window)},isUnbounded:function(){return!1},isSurfaceActive:function(){return e.$el[s.MATCHES](":active")},isSurfaceDisabled:function(){return e.disabled},addClass:function(t){e.$set(e.classes,t,!0)},removeClass:function(t){e.$delete(e.classes,t)},containsEventTarget:function(t){return e.$el.contains(t)},registerInteractionHandler:function(t,i){e.$el.addEventListener(t,i,_())},deregisterInteractionHandler:function(t,i){e.$el.removeEventListener(t,i,_())},registerDocumentInteractionHandler:function(e,t){return document.documentElement.addEventListener(e,t,_())},deregisterDocumentInteractionHandler:function(e,t){return document.documentElement.removeEventListener(e,t,_())},registerResizeHandler:function(e){return window.addEventListener("resize",e)},deregisterResizeHandler:function(e){return window.removeEventListener("resize",e)},updateCssVariable:function(t,i){e.$set(e.styles,t,i)},computeBoundingRect:function(){return e.$el.getBoundingClientRect()},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}}},i)))}return a(s,y),i(s,null,[{key:"isSurfaceActive",value:function(e){return e[s.MATCHES](":active")}},{key:"MATCHES",get:function(){return s._matches||(s._matches=(e=HTMLElement.prototype,["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(t){return t in e}).pop()));var e}}]),s}(),C={name:"mdc-ripple",mixins:[e,{data:function(){return{classes:{},styles:{}}},mounted:function(){this.ripple=new A(this),this.ripple.init()},beforeDestroy:function(){this.ripple.destroy()}}],props:{tag:String}},S=function(){var e=this.$createElement;return(this._self._c||e)("custom-element",{staticClass:"mdc-ripple",attrs:{tag:this.tag,classes:this.classes,styles:this.styles}},[this._t("default")],2)};S._withStripped=!0;!function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/ripple/mdc-ripple.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n}({render:S,staticRenderFns:[]},0,C,void 0,!1);var E={name:"mdc-list-item",inject:["mdcList"],props:{selected:Boolean,activated:Boolean},data:function(){return{classes:{},styles:{}}},computed:{itemClasses:function(){return{"mdc-list-item--selected":this.selected,"mdc-list-item--activated":this.activated}},isInteractive:function(){return this.mdcList&&this.mdcList.interactive},hasSecondary:function(){return this.$slots.secondary&&this.mdcList&&this.mdcList.twoLine},hasEndDetail:function(){return!!this.$slots["end-detail"]},hasStartDetail:function(){return!!this.$slots["start-detail"]}},watch:{isInteractive:function(e){e?this.addRipple():this.removeRipple()}},mounted:function(){this.isInteractive&&this.addRipple()},beforeDestroy:function(){this.removeRipple()},methods:{addRipple:function(){if(!this.ripple){var e=new A(this);e.init(),this.ripple=e}},removeRipple:function(){if(this.ripple){var e=this.ripple;this.ripple=null,e.destroy()}}}},b=function(){var e=this,t=e.$createElement,i=e._self._c||t;return i("li",e._g({staticClass:"mdc-list-item",class:[e.classes,e.itemClasses],style:e.styles,attrs:{tabindex:e.isInteractive?"0":void 0}},e.isInteractive?e.$listeners:{}),[e.hasStartDetail?i("span",{staticClass:"mdc-list-item__graphic"},[e._t("start-detail")],2):e._e(),e._v(" "),e.hasSecondary?i("span",{staticClass:"mdc-list-item__text"},[e._t("default"),e._v(" "),i("span",{staticClass:"mdc-list-item__secondary-text"},[e._t("secondary")],2)],2):e._t("default"),e._v(" "),e.hasEndDetail?i("span",{staticClass:"mdc-list-item__meta"},[e._t("end-detail")],2):e._e()],2)};b._withStripped=!0;var R=function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/list/mdc-list-item.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:b,staticRenderFns:[]},0,E,void 0,!1),T={name:"mdc-list-divider",props:{inset:Boolean,padded:Boolean},computed:{classes:function(){return{"mdc-list-divider--inset":this.inset,"mdc-list-divider--padded":this.padded}}}},I=function(){var e=this.$createElement;return(this._self._c||e)("li",{staticClass:"mdc-list-divider",class:this.classes,attrs:{role:"separator"}})};I._withStripped=!0;var w=function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/list/mdc-list-divider.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:I,staticRenderFns:[]},0,T,void 0,!1),k={name:"mdc-list-group"},H=function(){var e=this.$createElement;return(this._self._c||e)("div",{staticClass:"mdc-list-group"},[this._t("default")],2)};H._withStripped=!0;var D=function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/list/mdc-list-group.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:H,staticRenderFns:[]},0,k,void 0,!1),F={name:"mdc-list-group-header"},O=function(){var e=this.$createElement;return(this._self._c||e)("h3",{staticClass:"mdc-list-group-header mdc-list-group__subheader"},[this._t("default")],2)};O._withStripped=!0;var L=function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/list/mdc-list-group-header.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:O,staticRenderFns:[]},0,F,void 0,!1),V={name:"mdc-list-group-divider"},M=function(){var e=this.$createElement;return(this._self._c||e)("hr",{staticClass:"mdc-list-group-divider mdc-list-divider"})};M._withStripped=!0;var B,N=function(e,t,i,n,a,r,s,o){var c=("function"==typeof i?i.options:i)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/list/mdc-list-group-divider.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=n,c}({render:M,staticRenderFns:[]},0,V,void 0,!1),U={version:"0.18.1",install:function(e){for(var t in B){var i=B[t];e.component(i.name,i)}},components:B={mdcList:c,mdcListItem:R,mdcListDivider:w,mdcListGroup:D,mdcListGroupHeader:L,mdcListGroupDivider:N}};return function(e){var t=null;"undefined"!=typeof window?t=window.Vue:"undefined"!=typeof global&&(t=global.Vue),t&&t.use(e)}(U),U});
//# sourceMappingURL=list.min.js.map
