/**
* @module vue-mdc-adapterselect 0.18.1
* @exports VueMDCSelect
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"@material/tabs":"^0.38.0","material-components-web":"^0.38.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueMDCSelect=t()}(this,function(){"use strict";var e={components:{CustomElement:{functional:!0,render:function(e,t){return e(t.props.is||t.props.tag||"div",t.data,t.children)}}}},t=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},n=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),i=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(e[i]=n[i])}return e},a=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},s=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},r=(Math.floor(Math.random()*Math.floor(268435456)).toString(),function(){function e(){var n=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};t(this,e),this.adapter_=n}return n(e,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),n(e,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),e}()),o=(function(){function e(n){var i=arguments.length>1&&void 0!==arguments[1]?arguments[1]:void 0;t(this,e),this.root_=n;for(var a=arguments.length,s=Array(a>2?a-2:0),r=2;r<a;r++)s[r-2]=arguments[r];this.initialize.apply(this,s),this.foundation_=void 0===i?this.getDefaultFoundation():i,this.foundation_.init(),this.initialSyncWithDOM()}n(e,null,[{key:"attachTo",value:function(t){return new e(t,new r)}}]),n(e,[{key:"initialize",value:function(){}},{key:"getDefaultFoundation",value:function(){throw new Error("Subclasses must override getDefaultFoundation to return a properly configured foundation class")}},{key:"initialSyncWithDOM",value:function(){}},{key:"destroy",value:function(){this.foundation_.destroy()}},{key:"listen",value:function(e,t){this.root_.addEventListener(e,t)}},{key:"unlisten",value:function(e,t){this.root_.removeEventListener(e,t)}},{key:"emit",value:function(e,t){var n=arguments.length>2&&void 0!==arguments[2]&&arguments[2],i=void 0;"function"==typeof CustomEvent?i=new CustomEvent(e,{detail:t,bubbles:n}):(i=document.createEvent("CustomEvent")).initCustomEvent(e,n,!1,t),this.root_.dispatchEvent(i)}}])}(),{BOX:"mdc-select--box",DISABLED:"mdc-select--disabled",ROOT:"mdc-select",OUTLINED:"mdc-select--outlined"}),u={CHANGE_EVENT:"MDCSelect:change",LINE_RIPPLE_SELECTOR:".mdc-line-ripple",LABEL_SELECTOR:".mdc-floating-label",NATIVE_CONTROL_SELECTOR:".mdc-select__native-control",OUTLINE_SELECTOR:".mdc-notched-outline"},l={LABEL_SCALE:.75},c=function(e){function c(e){t(this,c);var n=s(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,i(c.defaultAdapter,e)));return n.focusHandler_=function(e){return n.handleFocus_(e)},n.blurHandler_=function(e){return n.handleBlur_(e)},n}return a(c,r),n(c,null,[{key:"cssClasses",get:function(){return o}},{key:"numbers",get:function(){return l}},{key:"strings",get:function(){return u}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},hasClass:function(){return!1},floatLabel:function(){},activateBottomLine:function(){},deactivateBottomLine:function(){},getValue:function(){},isRtl:function(){return!1},hasLabel:function(){},getLabelWidth:function(){},hasOutline:function(){},notchOutline:function(){},closeOutline:function(){}}}}]),n(c,[{key:"updateDisabledStyle",value:function(e){var t=c.cssClasses.DISABLED;e?this.adapter_.addClass(t):this.adapter_.removeClass(t)}},{key:"handleChange",value:function(){var e=this.adapter_.getValue().length>0;this.adapter_.floatLabel(e),this.notchOutline(e)}},{key:"handleFocus",value:function(){this.adapter_.floatLabel(!0),this.notchOutline(!0),this.adapter_.activateBottomLine()}},{key:"handleBlur",value:function(){this.handleChange(),this.adapter_.deactivateBottomLine()}},{key:"notchOutline",value:function(e){if(this.adapter_.hasOutline()&&this.adapter_.hasLabel())if(e){var t=l.LABEL_SCALE,n=this.adapter_.getLabelWidth()*t,i=this.adapter_.isRtl();this.adapter_.notchOutline(n,i)}else this.adapter_.closeOutline()}}]),c}(),d=(function(){function e(){t(this,e)}n(e,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"containsEventTarget",value:function(e){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}},{key:"registerDocumentInteractionHandler",value:function(e,t){}},{key:"deregisterDocumentInteractionHandler",value:function(e,t){}},{key:"registerResizeHandler",value:function(e){}},{key:"deregisterResizeHandler",value:function(e){}},{key:"updateCssVariable",value:function(e,t){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),f={VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},h={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:225,FG_DEACTIVATION_MS:150,TAP_DELAY_MS:300},v=void 0,_=void 0;function p(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window,t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===_||t){var n=!1;try{e.document.addEventListener("test",null,{get passive(){n=!0}})}catch(e){}_=n}return!!_&&{passive:!0}}
/**
   * @license
   * Copyright 2016 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */
var m=["touchstart","pointerdown","mousedown","keydown"],y=["touchend","pointerup","mouseup"],g=[],C=function(e){function o(e){t(this,o);var n=s(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,i(o.defaultAdapter,e)));return n.layoutFrame_=0,n.frame_={width:0,height:0},n.activationState_=n.defaultActivationState_(),n.initialSize_=0,n.maxRadius_=0,n.activateHandler_=function(e){return n.activate_(e)},n.deactivateHandler_=function(e){return n.deactivate_(e)},n.focusHandler_=function(){return n.handleFocus()},n.blurHandler_=function(){return n.handleBlur()},n.resizeHandler_=function(){return n.layout()},n.unboundedCoords_={left:0,top:0},n.fgScale_=0,n.activationTimer_=0,n.fgDeactivationRemovalTimer_=0,n.activationAnimationHasEnded_=!1,n.activationTimerCallback_=function(){n.activationAnimationHasEnded_=!0,n.runDeactivationUXLogicIfReady_()},n.previousActivationEvent_=null,n}return a(o,r),n(o,null,[{key:"cssClasses",get:function(){return d}},{key:"strings",get:function(){return f}},{key:"numbers",get:function(){return h}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},containsEventTarget:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerDocumentInteractionHandler:function(){},deregisterDocumentInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),n(o,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var e=this;if(this.isSupported_()){this.registerRootHandlers_();var t=o.cssClasses,n=t.ROOT,i=t.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.addClass(n),e.adapter_.isUnbounded()&&(e.adapter_.addClass(i),e.layoutInternal_())})}}},{key:"destroy",value:function(){var e=this;if(this.isSupported_()){if(this.activationTimer_){clearTimeout(this.activationTimer_),this.activationTimer_=0;var t=o.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(t)}this.deregisterRootHandlers_(),this.deregisterDeactivationHandlers_();var n=o.cssClasses,i=n.ROOT,a=n.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.removeClass(i),e.adapter_.removeClass(a),e.removeCssVars_()})}}},{key:"registerRootHandlers_",value:function(){var e=this;m.forEach(function(t){e.adapter_.registerInteractionHandler(t,e.activateHandler_)}),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"registerDeactivationHandlers_",value:function(e){var t=this;"keydown"===e.type?this.adapter_.registerInteractionHandler("keyup",this.deactivateHandler_):y.forEach(function(e){t.adapter_.registerDocumentInteractionHandler(e,t.deactivateHandler_)})}},{key:"deregisterRootHandlers_",value:function(){var e=this;m.forEach(function(t){e.adapter_.deregisterInteractionHandler(t,e.activateHandler_)}),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"deregisterDeactivationHandlers_",value:function(){var e=this;this.adapter_.deregisterInteractionHandler("keyup",this.deactivateHandler_),y.forEach(function(t){e.adapter_.deregisterDocumentInteractionHandler(t,e.deactivateHandler_)})}},{key:"removeCssVars_",value:function(){var e=this,t=o.strings;Object.keys(t).forEach(function(n){0===n.indexOf("VAR_")&&e.adapter_.updateCssVariable(t[n],null)})}},{key:"activate_",value:function(e){var t=this;if(!this.adapter_.isSurfaceDisabled()){var n=this.activationState_;if(!n.isActivated){var i=this.previousActivationEvent_;if(!(i&&e&&i.type!==e.type))n.isActivated=!0,n.isProgrammatic=null===e,n.activationEvent=e,n.wasActivatedByPointer=!n.isProgrammatic&&("mousedown"===e.type||"touchstart"===e.type||"pointerdown"===e.type),e&&g.length>0&&g.some(function(e){return t.adapter_.containsEventTarget(e)})?this.resetActivationState_():(e&&(g.push(e.target),this.registerDeactivationHandlers_(e)),n.wasElementMadeActive=this.checkElementMadeActive_(e),n.wasElementMadeActive&&this.animateActivation_(),requestAnimationFrame(function(){g=[],n.wasElementMadeActive||" "!==e.key&&32!==e.keyCode||(n.wasElementMadeActive=t.checkElementMadeActive_(e),n.wasElementMadeActive&&t.animateActivation_()),n.wasElementMadeActive||(t.activationState_=t.defaultActivationState_())}))}}}},{key:"checkElementMadeActive_",value:function(e){return!e||"keydown"!==e.type||this.adapter_.isSurfaceActive()}},{key:"activate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(e)}},{key:"animateActivation_",value:function(){var e=this,t=o.strings,n=t.VAR_FG_TRANSLATE_START,i=t.VAR_FG_TRANSLATE_END,a=o.cssClasses,s=a.FG_DEACTIVATION,r=a.FG_ACTIVATION,u=o.numbers.DEACTIVATION_TIMEOUT_MS;this.layoutInternal_();var l="",c="";if(!this.adapter_.isUnbounded()){var d=this.getFgTranslationCoordinates_(),f=d.startPoint,h=d.endPoint;l=f.x+"px, "+f.y+"px",c=h.x+"px, "+h.y+"px"}this.adapter_.updateCssVariable(n,l),this.adapter_.updateCssVariable(i,c),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(s),this.adapter_.computeBoundingRect(),this.adapter_.addClass(r),this.activationTimer_=setTimeout(function(){return e.activationTimerCallback_()},u)}},{key:"getFgTranslationCoordinates_",value:function(){var e,t,n,i,a,s,r,o,u,l=this.activationState_,c=l.activationEvent,d=void 0;return l.wasActivatedByPointer?(e=c,t=this.adapter_.getWindowPageOffset(),n=this.adapter_.computeBoundingRect(),i=t.x,a=t.y,s=i+n.left,r=a+n.top,o=void 0,u=void 0,"touchstart"===e.type?(o=e.changedTouches[0].pageX-s,u=e.changedTouches[0].pageY-r):(o=e.pageX-s,u=e.pageY-r),d={x:o,y:u}):d={x:this.frame_.width/2,y:this.frame_.height/2},{startPoint:d={x:d.x-this.initialSize_/2,y:d.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var e=this,t=o.cssClasses.FG_DEACTIVATION,n=this.activationState_,i=n.hasDeactivationUXRun,a=n.isActivated;(i||!a)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(t),this.fgDeactivationRemovalTimer_=setTimeout(function(){e.adapter_.removeClass(t)},h.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var e=o.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(e),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"resetActivationState_",value:function(){var e=this;this.previousActivationEvent_=this.activationState_.activationEvent,this.activationState_=this.defaultActivationState_(),setTimeout(function(){return e.previousActivationEvent_=null},o.numbers.TAP_DELAY_MS)}},{key:"deactivate_",value:function(e){var t=this,n=this.activationState_;if(n.isActivated){var a=i({},n);if(n.isProgrammatic){requestAnimationFrame(function(){return t.animateDeactivation_(null,a)}),this.resetActivationState_()}else this.deregisterDeactivationHandlers_(),requestAnimationFrame(function(){t.activationState_.hasDeactivationUXRun=!0,t.animateDeactivation_(e,a),t.resetActivationState_()})}}},{key:"deactivate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(e)}},{key:"animateDeactivation_",value:function(e,t){var n=t.wasActivatedByPointer,i=t.wasElementMadeActive;(n||i)&&this.runDeactivationUXLogicIfReady_()}},{key:"layout",value:function(){var e=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){e.layoutInternal_(),e.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){var e=this;this.frame_=this.adapter_.computeBoundingRect();var t=Math.max(this.frame_.height,this.frame_.width);this.maxRadius_=this.adapter_.isUnbounded()?t:Math.sqrt(Math.pow(e.frame_.width,2)+Math.pow(e.frame_.height,2))+o.numbers.PADDING,this.initialSize_=t*o.numbers.INITIAL_ORIGIN_SCALE,this.fgScale_=this.maxRadius_/this.initialSize_,this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var e=o.strings,t=e.VAR_FG_SIZE,n=e.VAR_LEFT,i=e.VAR_TOP,a=e.VAR_FG_SCALE;this.adapter_.updateCssVariable(t,this.initialSize_+"px"),this.adapter_.updateCssVariable(a,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(n,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(i,this.unboundedCoords_.top+"px"))}},{key:"setUnbounded",value:function(e){var t=o.cssClasses.UNBOUNDED;e?this.adapter_.addClass(t):this.adapter_.removeClass(t)}},{key:"handleFocus",value:function(){var e=this;requestAnimationFrame(function(){return e.adapter_.addClass(o.cssClasses.BG_FOCUSED)})}},{key:"handleBlur",value:function(){var e=this;requestAnimationFrame(function(){return e.adapter_.removeClass(o.cssClasses.BG_FOCUSED)})}}]),o}(),E=function(e){function r(e,n){return t(this,r),s(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,i({browserSupportsCssVars:function(){return function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=v;if("boolean"==typeof v&&!t)return n;if(e.CSS&&"function"==typeof e.CSS.supports){var i=e.CSS.supports("--css-vars","yes"),a=e.CSS.supports("(--css-vars: yes)")&&e.CSS.supports("color","#00000000");return n=!(!i&&!a||function(e){var t=e.document,n=t.createElement("div");n.className="mdc-ripple-surface--test-edge-var-bug",t.body.appendChild(n);var i=e.getComputedStyle(n),a=null!==i&&"solid"===i.borderTopStyle;return n.remove(),a}(e)),t||(v=n),n}}(window)},isUnbounded:function(){return!1},isSurfaceActive:function(){return e.$el[r.MATCHES](":active")},isSurfaceDisabled:function(){return e.disabled},addClass:function(t){e.$set(e.classes,t,!0)},removeClass:function(t){e.$delete(e.classes,t)},containsEventTarget:function(t){return e.$el.contains(t)},registerInteractionHandler:function(t,n){e.$el.addEventListener(t,n,p())},deregisterInteractionHandler:function(t,n){e.$el.removeEventListener(t,n,p())},registerDocumentInteractionHandler:function(e,t){return document.documentElement.addEventListener(e,t,p())},deregisterDocumentInteractionHandler:function(e,t){return document.documentElement.removeEventListener(e,t,p())},registerResizeHandler:function(e){return window.addEventListener("resize",e)},deregisterResizeHandler:function(e){return window.removeEventListener("resize",e)},updateCssVariable:function(t,n){e.$set(e.styles,t,n)},computeBoundingRect:function(){return e.$el.getBoundingClientRect()},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}}},n)))}return a(r,C),n(r,null,[{key:"isSurfaceActive",value:function(e){return e[r.MATCHES](":active")}},{key:"MATCHES",get:function(){return r._matches||(r._matches=(e=HTMLElement.prototype,["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(t){return t in e}).pop()));var e}}]),r}(),A={name:"mdc-ripple",mixins:[e,{data:function(){return{classes:{},styles:{}}},mounted:function(){this.ripple=new E(this),this.ripple.init()},beforeDestroy:function(){this.ripple.destroy()}}],props:{tag:String}},b=function(){var e=this.$createElement;return(this._self._c||e)("custom-element",{staticClass:"mdc-ripple",attrs:{tag:this.tag,classes:this.classes,styles:this.styles}},[this._t("default")],2)};b._withStripped=!0;!function(e,t,n,i,a,s,r,o){var u=("function"==typeof n?n.options:n)||{};u.__file="/home/travis/build/stasson/vue-mdc-adapter/components/ripple/mdc-ripple.vue",u.render||(u.render=e.render,u.staticRenderFns=e.staticRenderFns,u._compiled=!0,a&&(u.functional=!0)),u._scopeId=i}({render:b,staticRenderFns:[]},0,A,void 0,!1);
/**
   * @license
   * Copyright 2017 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */
!function(){function e(){t(this,e)}n(e,[{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"getWidth",value:function(){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}}])}();
/**
   * @license
   * Copyright 2016 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */var S={LABEL_FLOAT_ABOVE:"mdc-floating-label--float-above",LABEL_SHAKE:"mdc-floating-label--shake"},I=function(e){function o(e){t(this,o);var n=s(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,i(o.defaultAdapter,e)));return n.shakeAnimationEndHandler_=function(){return n.handleShakeAnimationEnd_()},n}return a(o,r),n(o,null,[{key:"cssClasses",get:function(){return S}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},getWidth:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){}}}}]),n(o,[{key:"init",value:function(){this.adapter_.registerInteractionHandler("animationend",this.shakeAnimationEndHandler_)}},{key:"destroy",value:function(){this.adapter_.deregisterInteractionHandler("animationend",this.shakeAnimationEndHandler_)}},{key:"getWidth",value:function(){return this.adapter_.getWidth()}},{key:"shake",value:function(e){var t=o.cssClasses.LABEL_SHAKE;e?this.adapter_.addClass(t):this.adapter_.removeClass(t)}},{key:"float",value:function(e){var t=o.cssClasses,n=t.LABEL_FLOAT_ABOVE,i=t.LABEL_SHAKE;e?this.adapter_.addClass(n):(this.adapter_.removeClass(n),this.adapter_.removeClass(i))}},{key:"handleShakeAnimationEnd_",value:function(){var e=o.cssClasses.LABEL_SHAKE;this.adapter_.removeClass(e)}}]),o}(),k={name:"mdc-select-label",data:function(){return{labelClasses:{}}},mounted:function(){var e=this;this.foundation=new I({addClass:function(t){e.$set(e.labelClasses,t,!0)},removeClass:function(t){e.$delete(e.labelClasses,t)},getWidth:function(){return e.$el.offsetWidth},registerInteractionHandler:function(t,n){e.$el.addEventListener(t,n)},deregisterInteractionHandler:function(t,n){e.$el.removeEventListener(t,n)}}),this.foundation.init()},beforeDestroy:function(){var e=this.foundation;this.foundation=null,e.destroy()}},T=function(){var e=this.$createElement;return(this._self._c||e)("label",{staticClass:"mdc-floating-label",class:this.labelClasses},[this._t("default")],2)};T._withStripped=!0;var O=function(e,t,n,i,a,s,r,o){var u=("function"==typeof n?n.options:n)||{};return u.__file="/home/travis/build/stasson/vue-mdc-adapter/components/select/mdc-select-label.vue",u.render||(u.render=e.render,u.staticRenderFns=e.staticRenderFns,u._compiled=!0,a&&(u.functional=!0)),u._scopeId=i,u}({render:T,staticRenderFns:[]},0,k,void 0,!1),L=(function(){function e(){t(this,e)}n(e,[{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"hasClass",value:function(e){}},{key:"setStyle",value:function(e,t){}},{key:"registerEventHandler",value:function(e,t){}},{key:"deregisterEventHandler",value:function(e,t){}}])}(),{LINE_RIPPLE_ACTIVE:"mdc-line-ripple--active",LINE_RIPPLE_DEACTIVATING:"mdc-line-ripple--deactivating"}),H=function(e){function o(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};t(this,o);var n=s(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,i(o.defaultAdapter,e)));return n.transitionEndHandler_=function(e){return n.handleTransitionEnd(e)},n}return a(o,r),n(o,null,[{key:"cssClasses",get:function(){return L}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},hasClass:function(){},setStyle:function(){},registerEventHandler:function(){},deregisterEventHandler:function(){}}}}]),n(o,[{key:"init",value:function(){this.adapter_.registerEventHandler("transitionend",this.transitionEndHandler_)}},{key:"destroy",value:function(){this.adapter_.deregisterEventHandler("transitionend",this.transitionEndHandler_)}},{key:"activate",value:function(){this.adapter_.removeClass(L.LINE_RIPPLE_DEACTIVATING),this.adapter_.addClass(L.LINE_RIPPLE_ACTIVE)}},{key:"setRippleCenter",value:function(e){this.adapter_.setStyle("transform-origin",e+"px center")}},{key:"deactivate",value:function(){this.adapter_.addClass(L.LINE_RIPPLE_DEACTIVATING)}},{key:"handleTransitionEnd",value:function(e){var t=this.adapter_.hasClass(L.LINE_RIPPLE_DEACTIVATING);"opacity"===e.propertyName&&t&&(this.adapter_.removeClass(L.LINE_RIPPLE_ACTIVE),this.adapter_.removeClass(L.LINE_RIPPLE_DEACTIVATING))}}]),o}(),R={name:"mdc-select-line-ripple",data:function(){return{lineClasses:{},lineStyles:{}}},mounted:function(){var e=this;this.foundation=new H({addClass:function(t){e.$set(e.lineClasses,t,!0)},removeClass:function(t){e.$delete(e.lineClasses,t)},hasClass:function(t){e.$el.classList.contains(t)},setStyle:function(t,n){e.$set(e.lineStyles,t,n)},registerEventHandler:function(t,n){e.$el.addEventListener(t,n)},deregisterEventHandler:function(t,n){e.$el.removeEventListener(t,n)}}),this.foundation.init()},beforeDestroy:function(){var e=this.foundation;this.foundation=null,e.destroy()}},w=function(){var e=this.$createElement;return(this._self._c||e)("div",{staticClass:"mdc-line-ripple",class:this.lineClasses,style:this.lineStyles})};
/**
   * @license
   * Copyright 2018 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */w._withStripped=!0;var D=function(e,t,n,i,a,s,r,o){var u=("function"==typeof n?n.options:n)||{};return u.__file="/home/travis/build/stasson/vue-mdc-adapter/components/select/mdc-select-line-ripple.vue",u.render||(u.render=e.render,u.staticRenderFns=e.staticRenderFns,u._compiled=!0,a&&(u.functional=!0)),u._scopeId=i,u}({render:w,staticRenderFns:[]},0,R,void 0,!1),V=(function(){function e(){t(this,e)}n(e,[{key:"getWidth",value:function(){}},{key:"getHeight",value:function(){}},{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"setOutlinePathAttr",value:function(e){}},{key:"getIdleOutlineStyleValue",value:function(e){}}])}(),{PATH_SELECTOR:".mdc-notched-outline__path",IDLE_OUTLINE_SELECTOR:".mdc-notched-outline__idle"}),F={OUTLINE_NOTCHED:"mdc-notched-outline--notched"},N=function(e){function o(e){return t(this,o),s(this,(o.__proto__||Object.getPrototypeOf(o)).call(this,i(o.defaultAdapter,e)))}return a(o,r),n(o,null,[{key:"strings",get:function(){return V}},{key:"cssClasses",get:function(){return F}},{key:"defaultAdapter",get:function(){return{getWidth:function(){},getHeight:function(){},addClass:function(){},removeClass:function(){},setOutlinePathAttr:function(){},getIdleOutlineStyleValue:function(){}}}}]),n(o,[{key:"notch",value:function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=o.cssClasses.OUTLINE_NOTCHED;this.adapter_.addClass(n),this.updateSvgPath_(e,t)}},{key:"closeNotch",value:function(){var e=o.cssClasses.OUTLINE_NOTCHED;this.adapter_.removeClass(e)}},{key:"updateSvgPath_",value:function(e,t){var n=this.adapter_.getIdleOutlineStyleValue("border-radius")||this.adapter_.getIdleOutlineStyleValue("border-top-left-radius"),i=parseFloat(n),a=this.adapter_.getWidth(),s=this.adapter_.getHeight(),r=i+1.2,o=Math.abs(11-r),u=e+8,l="a"+i+","+i+" 0 0 1 "+i+","+i+"v"+(s-2*r)+"a"+i+","+i+" 0 0 1 "+-i+","+i+"h"+(2*r-a)+"a"+i+","+i+" 0 0 1 "+-i+","+-i+"v"+(2*r-s)+"a"+i+","+i+" 0 0 1 "+i+","+-i,c=void 0;c=t?"M"+(a-r-o)+",1h"+o+l+"h"+(a-2*r-u-o):"M"+(r+o+u)+",1h"+(a-2*r-u-o)+l+"h"+o,this.adapter_.setOutlinePathAttr(c)}}]),o}(),P={name:"mdc-select-notched-outline",data:function(){return{outlinedClasses:{}}},mounted:function(){var e=this;this.foundation=new N({getWidth:function(){return e.$refs.outlined.offsetWidth},getHeight:function(){return e.$refs.outlined.offsetHeight},addClass:function(t){e.$set(e.outlinedClasses,t,!0)},removeClass:function(t){e.$delete(e.outlinedClasses,t)},setOutlinePathAttr:function(t){e.$refs.outlinedPath.setAttribute("d",t)},getIdleOutlineStyleValue:function(t){return window.getComputedStyle(e.$refs.outlinedIdle).getPropertyValue(t)}}),this.foundation.init()},beforeDestroy:function(){var e=this.foundation;this.foundation=null,e.destroy()}},$=function(){var e=this.$createElement,t=this._self._c||e;return t("div",[t("div",{ref:"outlined",staticClass:"mdc-notched-outline",class:this.outlinedClasses},[t("svg",[t("path",{ref:"outlinedPath",staticClass:"mdc-notched-outline__path"})])]),this._v(" "),t("div",{ref:"outlinedIdle",staticClass:"mdc-notched-outline__idle"})])};
/**
   * @license
   * Copyright 2017 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */$._withStripped=!0;var B={name:"mdc-select",components:{SelectLabel:O,SelectLineRiple:D,SelectNotchedOutline:function(e,t,n,i,a,s,r,o){var u=("function"==typeof n?n.options:n)||{};return u.__file="/home/travis/build/stasson/vue-mdc-adapter/components/select/mdc-select-notched-outline.vue",u.render||(u.render=e.render,u.staticRenderFns=e.staticRenderFns,u._compiled=!0,a&&(u.functional=!0)),u._scopeId=i,u}({render:$,staticRenderFns:[]},0,P,void 0,!1)},inheritAttrs:!1,model:{prop:"value",event:"change"},props:{value:String,disabled:Boolean,label:String,outlined:Boolean,id:{type:String}},data:function(){return{styles:{},classes:{}}},computed:{rootClasses:function(){return i({"mdc-select--box":!this.outlined,"mdc-select--outlined":this.outlined},this.classes)},listeners:function(){var e=this;return i({},this.$listeners,{change:function(t){return e.onChange(t)}})}},watch:{disabled:function(e){this.foundation&&this.foundation.updateDisabledStyle(e)},value:"refreshIndex"},mounted:function(){var e=this;this.foundation=new c({addClass:function(t){return e.$set(e.classes,t,!0)},removeClass:function(t){return e.$delete(e.classes,t)},hasClass:function(t){return e.$el.classList.contains(t)},activateBottomLine:function(){e.$refs.line&&e.$refs.line.foundation.activate()},deactivateBottomLine:function(){e.$refs.line&&e.$refs.line.foundation.deactivate()},getValue:function(){return e.$refs.native_control.value},isRtl:function(){return"rtl"===window.getComputedStyle(e.$el).getPropertyValue("direction")},notchOutline:function(t,n){e.$refs.outline&&e.$refs.outline.foundation.notch(t,n)},closeOutline:function(){e.$refs.outline&&e.$refs.outline.foundation.closeNotch()},hasOutline:function(){return!!e.$refs.outline},floatLabel:function(t){e.$refs.label&&e.$refs.label.foundation.float(t)},hasLabel:function(){return!!e.$refs.label},getLabelWidth:function(){if(e.$refs.label)return e.$refs.label.foundation.getWidth()}}),this.foundation.init(),this.foundation.handleChange(),this.refreshIndex(),this.slotObserver=new MutationObserver(function(){return e.refreshIndex()}),this.slotObserver.observe(this.$refs.native_control,{childList:!0,subtree:!0}),this.ripple=new E(this),this.ripple.init()},beforeDestroy:function(){this.slotObserver.disconnect();var e=this.foundation;this.foundation=null,e.destroy(),this.ripple&&this.ripple.destroy()},methods:{refreshIndex:function(){var e=this,t=[].concat(function(e){if(Array.isArray(e)){for(var t=0,n=Array(e.length);t<e.length;t++)n[t]=e[t];return n}return Array.from(e)}(this.$refs.native_control.querySelectorAll("option"))).findIndex(function(t){var n=t.value;return e.value===n});this.$refs.native_control.selectedIndex!==t&&(this.$refs.native_control.selectedIndex=t,this.foundation.handleChange())},onChange:function(e){this.foundation.handleChange(),this.$emit("change",e.target.value)}}},M=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"mdc-select",class:e.rootClasses,style:e.styles,attrs:{id:e.id}},[n("select",e._g(e._b({ref:"native_control",staticClass:"mdc-select__native-control",attrs:{disabled:e.disabled}},"select",e.$attrs,!1),e.listeners),[e.label?n("option",{staticClass:"mdc-option",attrs:{value:"",disabled:"",selected:""}}):e._e(),e._v(" "),e._t("default")],2),e._v(" "),e.label?n("select-label",{ref:"label"},[e._v(e._s(e.label))]):e._e(),e._v(" "),e.outlined?e._e():n("select-line-riple",{ref:"line"}),e._v(" "),e.outlined?n("select-notched-outline",{ref:"outline"}):e._e()],1)};M._withStripped=!0;var x,U=function(e,t,n,i,a,s,r,o){var u=("function"==typeof n?n.options:n)||{};return u.__file="/home/travis/build/stasson/vue-mdc-adapter/components/select/mdc-select.vue",u.render||(u.render=e.render,u.staticRenderFns=e.staticRenderFns,u._compiled=!0,a&&(u.functional=!0)),u._scopeId=i,u}({render:M,staticRenderFns:[]},0,B,void 0,!1),G={version:"0.18.1",install:function(e){for(var t in x){var n=x[t];e.component(n.name,n)}},components:x={mdcSelect:U}};return function(e){var t=null;"undefined"!=typeof window?t=window.Vue:"undefined"!=typeof global&&(t=global.Vue),t&&t.use(e)}(G),G});
//# sourceMappingURL=select.min.js.map
