/**
* @module vue-mdc-adapterswitch 0.18.1
* @exports VueMDCSwitch
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"@material/tabs":"^0.38.0","material-components-web":"^0.38.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(e,t){"object"==typeof exports&&"undefined"!=typeof module?module.exports=t():"function"==typeof define&&define.amd?define(t):e.VueMDCSwitch=t()}(this,function(){"use strict";var e={components:{CustomElement:{functional:!0,render:function(e,t){return e(t.props.is||t.props.tag||"div",t.data,t.children)}}}},t=function(e,t){if(!(e instanceof t))throw new TypeError("Cannot call a class as a function")},n=function(){function e(e,t){for(var n=0;n<t.length;n++){var i=t[n];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(e,i.key,i)}}return function(t,n,i){return n&&e(t.prototype,n),i&&e(t,i),t}}(),i=Object.assign||function(e){for(var t=1;t<arguments.length;t++){var n=arguments[t];for(var i in n)Object.prototype.hasOwnProperty.call(n,i)&&(e[i]=n[i])}return e},a=function(e,t){if("function"!=typeof t&&null!==t)throw new TypeError("Super expression must either be null or a function, not "+typeof t);e.prototype=Object.create(t&&t.prototype,{constructor:{value:e,enumerable:!1,writable:!0,configurable:!0}}),t&&(Object.setPrototypeOf?Object.setPrototypeOf(e,t):e.__proto__=t)},s=function(e,t){if(!e)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!t||"object"!=typeof t&&"function"!=typeof t?e:t},r={data:function(){return{hasFocus:!1}},methods:{onMouseDown:function(){this._active=!0},onMouseUp:function(){this._active=!1},onFocusEvent:function(){var e=this;setTimeout(function(){return e.dispatchFocusEvent()},0)},onBlurEvent:function(){var e=this;this._active||setTimeout(function(){return e.dispatchFocusEvent()},0)},dispatchFocusEvent:function(){var e=this.$el===document.activeElement||this.$el.contains(document.activeElement);e!=this.hasFocus&&(this.$emit(e?"focus":"blur"),this.hasFocus=e)}},mounted:function(){this.$el.addEventListener("focusin",this.onFocusEvent),this.$el.addEventListener("focusout",this.onBlurEvent),this.$el.addEventListener("mousedown",this.onMouseDown),this.$el.addEventListener("mouseup",this.onMouseUp)},beforeDestroy:function(){this.$el.removeEventListener("focusin",this.onFocusEvent),this.$el.removeEventListener("focusout",this.onBlurEvent),this.$el.removeEventListener("mousedown",this.onMouseDown),this.$el.removeEventListener("mouseup",this.onMouseUp)}},o=Math.floor(Math.random()*Math.floor(268435456)).toString()+"-",c={beforeCreate:function(){this.vma_uid_=o+this._uid}},u=function(){function e(){var n=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};t(this,e),this.adapter_=n}return n(e,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),n(e,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),e}(),d=(function(){function e(){t(this,e)}n(e,[{key:"browserSupportsCssVars",value:function(){}},{key:"isUnbounded",value:function(){}},{key:"isSurfaceActive",value:function(){}},{key:"isSurfaceDisabled",value:function(){}},{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"containsEventTarget",value:function(e){}},{key:"registerInteractionHandler",value:function(e,t){}},{key:"deregisterInteractionHandler",value:function(e,t){}},{key:"registerDocumentInteractionHandler",value:function(e,t){}},{key:"deregisterDocumentInteractionHandler",value:function(e,t){}},{key:"registerResizeHandler",value:function(e){}},{key:"deregisterResizeHandler",value:function(e){}},{key:"updateCssVariable",value:function(e,t){}},{key:"computeBoundingRect",value:function(){}},{key:"getWindowPageOffset",value:function(){}}])}(),{ROOT:"mdc-ripple-upgraded",UNBOUNDED:"mdc-ripple-upgraded--unbounded",BG_FOCUSED:"mdc-ripple-upgraded--background-focused",FG_ACTIVATION:"mdc-ripple-upgraded--foreground-activation",FG_DEACTIVATION:"mdc-ripple-upgraded--foreground-deactivation"}),l={VAR_LEFT:"--mdc-ripple-left",VAR_TOP:"--mdc-ripple-top",VAR_FG_SIZE:"--mdc-ripple-fg-size",VAR_FG_SCALE:"--mdc-ripple-fg-scale",VAR_FG_TRANSLATE_START:"--mdc-ripple-fg-translate-start",VAR_FG_TRANSLATE_END:"--mdc-ripple-fg-translate-end"},f={PADDING:10,INITIAL_ORIGIN_SCALE:.6,DEACTIVATION_TIMEOUT_MS:225,FG_DEACTIVATION_MS:150,TAP_DELAY_MS:300},v=void 0,h=void 0;function _(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:window,t=arguments.length>1&&void 0!==arguments[1]&&arguments[1];if(void 0===h||t){var n=!1;try{e.document.addEventListener("test",null,{get passive(){n=!0}})}catch(e){}h=n}return!!h&&{passive:!0}}
/**
   * @license
   * Copyright 2016 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */
var p=["touchstart","pointerdown","mousedown","keydown"],m=["touchend","pointerup","mouseup"],y=[],g=function(e){function r(e){t(this,r);var n=s(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,i(r.defaultAdapter,e)));return n.layoutFrame_=0,n.frame_={width:0,height:0},n.activationState_=n.defaultActivationState_(),n.initialSize_=0,n.maxRadius_=0,n.activateHandler_=function(e){return n.activate_(e)},n.deactivateHandler_=function(e){return n.deactivate_(e)},n.focusHandler_=function(){return n.handleFocus()},n.blurHandler_=function(){return n.handleBlur()},n.resizeHandler_=function(){return n.layout()},n.unboundedCoords_={left:0,top:0},n.fgScale_=0,n.activationTimer_=0,n.fgDeactivationRemovalTimer_=0,n.activationAnimationHasEnded_=!1,n.activationTimerCallback_=function(){n.activationAnimationHasEnded_=!0,n.runDeactivationUXLogicIfReady_()},n.previousActivationEvent_=null,n}return a(r,u),n(r,null,[{key:"cssClasses",get:function(){return d}},{key:"strings",get:function(){return l}},{key:"numbers",get:function(){return f}},{key:"defaultAdapter",get:function(){return{browserSupportsCssVars:function(){},isUnbounded:function(){},isSurfaceActive:function(){},isSurfaceDisabled:function(){},addClass:function(){},removeClass:function(){},containsEventTarget:function(){},registerInteractionHandler:function(){},deregisterInteractionHandler:function(){},registerDocumentInteractionHandler:function(){},deregisterDocumentInteractionHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},updateCssVariable:function(){},computeBoundingRect:function(){},getWindowPageOffset:function(){}}}}]),n(r,[{key:"isSupported_",value:function(){return this.adapter_.browserSupportsCssVars()}},{key:"defaultActivationState_",value:function(){return{isActivated:!1,hasDeactivationUXRun:!1,wasActivatedByPointer:!1,wasElementMadeActive:!1,activationEvent:null,isProgrammatic:!1}}},{key:"init",value:function(){var e=this;if(this.isSupported_()){this.registerRootHandlers_();var t=r.cssClasses,n=t.ROOT,i=t.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.addClass(n),e.adapter_.isUnbounded()&&(e.adapter_.addClass(i),e.layoutInternal_())})}}},{key:"destroy",value:function(){var e=this;if(this.isSupported_()){if(this.activationTimer_){clearTimeout(this.activationTimer_),this.activationTimer_=0;var t=r.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(t)}this.deregisterRootHandlers_(),this.deregisterDeactivationHandlers_();var n=r.cssClasses,i=n.ROOT,a=n.UNBOUNDED;requestAnimationFrame(function(){e.adapter_.removeClass(i),e.adapter_.removeClass(a),e.removeCssVars_()})}}},{key:"registerRootHandlers_",value:function(){var e=this;p.forEach(function(t){e.adapter_.registerInteractionHandler(t,e.activateHandler_)}),this.adapter_.registerInteractionHandler("focus",this.focusHandler_),this.adapter_.registerInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.registerResizeHandler(this.resizeHandler_)}},{key:"registerDeactivationHandlers_",value:function(e){var t=this;"keydown"===e.type?this.adapter_.registerInteractionHandler("keyup",this.deactivateHandler_):m.forEach(function(e){t.adapter_.registerDocumentInteractionHandler(e,t.deactivateHandler_)})}},{key:"deregisterRootHandlers_",value:function(){var e=this;p.forEach(function(t){e.adapter_.deregisterInteractionHandler(t,e.activateHandler_)}),this.adapter_.deregisterInteractionHandler("focus",this.focusHandler_),this.adapter_.deregisterInteractionHandler("blur",this.blurHandler_),this.adapter_.isUnbounded()&&this.adapter_.deregisterResizeHandler(this.resizeHandler_)}},{key:"deregisterDeactivationHandlers_",value:function(){var e=this;this.adapter_.deregisterInteractionHandler("keyup",this.deactivateHandler_),m.forEach(function(t){e.adapter_.deregisterDocumentInteractionHandler(t,e.deactivateHandler_)})}},{key:"removeCssVars_",value:function(){var e=this,t=r.strings;Object.keys(t).forEach(function(n){0===n.indexOf("VAR_")&&e.adapter_.updateCssVariable(t[n],null)})}},{key:"activate_",value:function(e){var t=this;if(!this.adapter_.isSurfaceDisabled()){var n=this.activationState_;if(!n.isActivated){var i=this.previousActivationEvent_;if(!(i&&e&&i.type!==e.type))n.isActivated=!0,n.isProgrammatic=null===e,n.activationEvent=e,n.wasActivatedByPointer=!n.isProgrammatic&&("mousedown"===e.type||"touchstart"===e.type||"pointerdown"===e.type),e&&y.length>0&&y.some(function(e){return t.adapter_.containsEventTarget(e)})?this.resetActivationState_():(e&&(y.push(e.target),this.registerDeactivationHandlers_(e)),n.wasElementMadeActive=this.checkElementMadeActive_(e),n.wasElementMadeActive&&this.animateActivation_(),requestAnimationFrame(function(){y=[],n.wasElementMadeActive||" "!==e.key&&32!==e.keyCode||(n.wasElementMadeActive=t.checkElementMadeActive_(e),n.wasElementMadeActive&&t.animateActivation_()),n.wasElementMadeActive||(t.activationState_=t.defaultActivationState_())}))}}}},{key:"checkElementMadeActive_",value:function(e){return!e||"keydown"!==e.type||this.adapter_.isSurfaceActive()}},{key:"activate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.activate_(e)}},{key:"animateActivation_",value:function(){var e=this,t=r.strings,n=t.VAR_FG_TRANSLATE_START,i=t.VAR_FG_TRANSLATE_END,a=r.cssClasses,s=a.FG_DEACTIVATION,o=a.FG_ACTIVATION,c=r.numbers.DEACTIVATION_TIMEOUT_MS;this.layoutInternal_();var u="",d="";if(!this.adapter_.isUnbounded()){var l=this.getFgTranslationCoordinates_(),f=l.startPoint,v=l.endPoint;u=f.x+"px, "+f.y+"px",d=v.x+"px, "+v.y+"px"}this.adapter_.updateCssVariable(n,u),this.adapter_.updateCssVariable(i,d),clearTimeout(this.activationTimer_),clearTimeout(this.fgDeactivationRemovalTimer_),this.rmBoundedActivationClasses_(),this.adapter_.removeClass(s),this.adapter_.computeBoundingRect(),this.adapter_.addClass(o),this.activationTimer_=setTimeout(function(){return e.activationTimerCallback_()},c)}},{key:"getFgTranslationCoordinates_",value:function(){var e,t,n,i,a,s,r,o,c,u=this.activationState_,d=u.activationEvent,l=void 0;return u.wasActivatedByPointer?(e=d,t=this.adapter_.getWindowPageOffset(),n=this.adapter_.computeBoundingRect(),i=t.x,a=t.y,s=i+n.left,r=a+n.top,o=void 0,c=void 0,"touchstart"===e.type?(o=e.changedTouches[0].pageX-s,c=e.changedTouches[0].pageY-r):(o=e.pageX-s,c=e.pageY-r),l={x:o,y:c}):l={x:this.frame_.width/2,y:this.frame_.height/2},{startPoint:l={x:l.x-this.initialSize_/2,y:l.y-this.initialSize_/2},endPoint:{x:this.frame_.width/2-this.initialSize_/2,y:this.frame_.height/2-this.initialSize_/2}}}},{key:"runDeactivationUXLogicIfReady_",value:function(){var e=this,t=r.cssClasses.FG_DEACTIVATION,n=this.activationState_,i=n.hasDeactivationUXRun,a=n.isActivated;(i||!a)&&this.activationAnimationHasEnded_&&(this.rmBoundedActivationClasses_(),this.adapter_.addClass(t),this.fgDeactivationRemovalTimer_=setTimeout(function(){e.adapter_.removeClass(t)},f.FG_DEACTIVATION_MS))}},{key:"rmBoundedActivationClasses_",value:function(){var e=r.cssClasses.FG_ACTIVATION;this.adapter_.removeClass(e),this.activationAnimationHasEnded_=!1,this.adapter_.computeBoundingRect()}},{key:"resetActivationState_",value:function(){var e=this;this.previousActivationEvent_=this.activationState_.activationEvent,this.activationState_=this.defaultActivationState_(),setTimeout(function(){return e.previousActivationEvent_=null},r.numbers.TAP_DELAY_MS)}},{key:"deactivate_",value:function(e){var t=this,n=this.activationState_;if(n.isActivated){var a=i({},n);if(n.isProgrammatic){requestAnimationFrame(function(){return t.animateDeactivation_(null,a)}),this.resetActivationState_()}else this.deregisterDeactivationHandlers_(),requestAnimationFrame(function(){t.activationState_.hasDeactivationUXRun=!0,t.animateDeactivation_(e,a),t.resetActivationState_()})}}},{key:"deactivate",value:function(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:null;this.deactivate_(e)}},{key:"animateDeactivation_",value:function(e,t){var n=t.wasActivatedByPointer,i=t.wasElementMadeActive;(n||i)&&this.runDeactivationUXLogicIfReady_()}},{key:"layout",value:function(){var e=this;this.layoutFrame_&&cancelAnimationFrame(this.layoutFrame_),this.layoutFrame_=requestAnimationFrame(function(){e.layoutInternal_(),e.layoutFrame_=0})}},{key:"layoutInternal_",value:function(){var e=this;this.frame_=this.adapter_.computeBoundingRect();var t=Math.max(this.frame_.height,this.frame_.width);this.maxRadius_=this.adapter_.isUnbounded()?t:Math.sqrt(Math.pow(e.frame_.width,2)+Math.pow(e.frame_.height,2))+r.numbers.PADDING,this.initialSize_=t*r.numbers.INITIAL_ORIGIN_SCALE,this.fgScale_=this.maxRadius_/this.initialSize_,this.updateLayoutCssVars_()}},{key:"updateLayoutCssVars_",value:function(){var e=r.strings,t=e.VAR_FG_SIZE,n=e.VAR_LEFT,i=e.VAR_TOP,a=e.VAR_FG_SCALE;this.adapter_.updateCssVariable(t,this.initialSize_+"px"),this.adapter_.updateCssVariable(a,this.fgScale_),this.adapter_.isUnbounded()&&(this.unboundedCoords_={left:Math.round(this.frame_.width/2-this.initialSize_/2),top:Math.round(this.frame_.height/2-this.initialSize_/2)},this.adapter_.updateCssVariable(n,this.unboundedCoords_.left+"px"),this.adapter_.updateCssVariable(i,this.unboundedCoords_.top+"px"))}},{key:"setUnbounded",value:function(e){var t=r.cssClasses.UNBOUNDED;e?this.adapter_.addClass(t):this.adapter_.removeClass(t)}},{key:"handleFocus",value:function(){var e=this;requestAnimationFrame(function(){return e.adapter_.addClass(r.cssClasses.BG_FOCUSED)})}},{key:"handleBlur",value:function(){var e=this;requestAnimationFrame(function(){return e.adapter_.removeClass(r.cssClasses.BG_FOCUSED)})}}]),r}(),C=function(e){function r(e,n){return t(this,r),s(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,i({browserSupportsCssVars:function(){return function(e){var t=arguments.length>1&&void 0!==arguments[1]&&arguments[1],n=v;if("boolean"==typeof v&&!t)return n;if(e.CSS&&"function"==typeof e.CSS.supports){var i=e.CSS.supports("--css-vars","yes"),a=e.CSS.supports("(--css-vars: yes)")&&e.CSS.supports("color","#00000000");return n=!(!i&&!a||function(e){var t=e.document,n=t.createElement("div");n.className="mdc-ripple-surface--test-edge-var-bug",t.body.appendChild(n);var i=e.getComputedStyle(n),a=null!==i&&"solid"===i.borderTopStyle;return n.remove(),a}(e)),t||(v=n),n}}(window)},isUnbounded:function(){return!1},isSurfaceActive:function(){return e.$el[r.MATCHES](":active")},isSurfaceDisabled:function(){return e.disabled},addClass:function(t){e.$set(e.classes,t,!0)},removeClass:function(t){e.$delete(e.classes,t)},containsEventTarget:function(t){return e.$el.contains(t)},registerInteractionHandler:function(t,n){e.$el.addEventListener(t,n,_())},deregisterInteractionHandler:function(t,n){e.$el.removeEventListener(t,n,_())},registerDocumentInteractionHandler:function(e,t){return document.documentElement.addEventListener(e,t,_())},deregisterDocumentInteractionHandler:function(e,t){return document.documentElement.removeEventListener(e,t,_())},registerResizeHandler:function(e){return window.addEventListener("resize",e)},deregisterResizeHandler:function(e){return window.removeEventListener("resize",e)},updateCssVariable:function(t,n){e.$set(e.styles,t,n)},computeBoundingRect:function(){return e.$el.getBoundingClientRect()},getWindowPageOffset:function(){return{x:window.pageXOffset,y:window.pageYOffset}}},n)))}return a(r,g),n(r,null,[{key:"isSurfaceActive",value:function(e){return e[r.MATCHES](":active")}},{key:"MATCHES",get:function(){return r._matches||(r._matches=(e=HTMLElement.prototype,["webkitMatchesSelector","msMatchesSelector","matches"].filter(function(t){return t in e}).pop()));var e}}]),r}(),A={name:"mdc-ripple",mixins:[e,{data:function(){return{classes:{},styles:{}}},mounted:function(){this.ripple=new C(this),this.ripple.init()},beforeDestroy:function(){this.ripple.destroy()}}],props:{tag:String}},E=function(){var e=this.$createElement;return(this._self._c||e)("custom-element",{staticClass:"mdc-ripple",attrs:{tag:this.tag,classes:this.classes,styles:this.styles}},[this._t("default")],2)};E._withStripped=!0;!function(e,t,n,i,a,s,r,o){var c=("function"==typeof n?n.options:n)||{};c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/ripple/mdc-ripple.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=i}({render:E,staticRenderFns:[]},0,A,void 0,!1);
/**
   * @license
   * Copyright 2018 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */
!function(){function e(){t(this,e)}n(e,[{key:"addClass",value:function(e){}},{key:"removeClass",value:function(e){}},{key:"setNativeControlChecked",value:function(e){}},{key:"isNativeControlChecked",value:function(){}},{key:"setNativeControlDisabled",value:function(e){}},{key:"isNativeControlDisabled",value:function(){}}])}();
/**
   * @license
   * Copyright 2018 Google Inc. All Rights Reserved.
   *
   * Licensed under the Apache License, Version 2.0 (the "License");
   * you may not use this file except in compliance with the License.
   * You may obtain a copy of the License at
   *
   *      http://www.apache.org/licenses/LICENSE-2.0
   *
   * Unless required by applicable law or agreed to in writing, software
   * distributed under the License is distributed on an "AS IS" BASIS,
   * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
   * See the License for the specific language governing permissions and
   * limitations under the License.
   */var b={CHECKED:"mdc-switch--checked",DISABLED:"mdc-switch--disabled"},k={NATIVE_CONTROL_SELECTOR:".mdc-switch__native-control",RIPPLE_SURFACE_SELECTOR:".mdc-switch__thumb-underlay"},S=function(e){function r(e){return t(this,r),s(this,(r.__proto__||Object.getPrototypeOf(r)).call(this,i(r.defaultAdapter,e)))}return a(r,u),n(r,null,[{key:"strings",get:function(){return k}},{key:"cssClasses",get:function(){return b}},{key:"defaultAdapter",get:function(){return{addClass:function(){},removeClass:function(){},setNativeControlChecked:function(){},isNativeControlChecked:function(){},setNativeControlDisabled:function(){},isNativeControlDisabled:function(){}}}}]),n(r,[{key:"init",value:function(){this.handleChange()}},{key:"isChecked",value:function(){return this.adapter_.isNativeControlChecked()}},{key:"setChecked",value:function(e){this.adapter_.setNativeControlChecked(e),this.updateCheckedStyling_(e)}},{key:"isDisabled",value:function(){return this.adapter_.isNativeControlDisabled()}},{key:"setDisabled",value:function(e){this.adapter_.setNativeControlDisabled(e),e?this.adapter_.addClass(b.DISABLED):this.adapter_.removeClass(b.DISABLED)}},{key:"handleChange",value:function(){this.updateCheckedStyling_(this.isChecked())}},{key:"updateCheckedStyling_",value:function(e){e?this.adapter_.addClass(b.CHECKED):this.adapter_.removeClass(b.CHECKED)}}]),r}(),w={name:"mdc-switch",mixins:[r,c],model:{prop:"checked",event:"change"},props:{checked:Boolean,disabled:Boolean,value:String,label:String,alignEnd:Boolean,name:String},data:function(){return{classes:{},styles:{}}},computed:{hasLabel:function(){return this.label||this.$slots.default}},watch:{checked:function(e){this.foundation&&this.foundation.setChecked(e)},disabled:function(e){this.foundation&&this.foundation.setDisabled(e)}},mounted:function(){var e=this;this.foundation=new S({addClass:function(t){return e.$set(e.classes,t,!0)},removeClass:function(t){return e.$delete(e.classes,t)},setNativeControlChecked:function(t){return e.$refs.control.checked=t},isNativeControlChecked:function(){return e.$refs.control.checked},setNativeControlDisabled:function(t){return e.$refs.control.disabled=t},isNativeControlDisabled:function(){return e.nativeControl_.disabled}}),this.foundation.init(),this.foundation.setChecked(this.checked),this.foundation.setDisabled(this.disabled),this.ripple=new C(this),this.ripple.init()},beforeDestroy:function(){this.foundation&&this.foundation.destroy(),this.ripple&&this.ripple.destroy()},methods:{onChanged:function(e){this.foundation&&this.foundation.handleChange(),this.$emit("change",e.target.checked)}}},T=function(){var e=this,t=e.$createElement,n=e._self._c||t;return n("div",{staticClass:"mdc-switch-wrapper",class:{"mdc-form-field":e.hasLabel,"mdc-form-field--align-end":e.hasLabel&&e.alignEnd}},[n("div",{staticClass:"mdc-switch",class:e.classes,attrs:{styles:e.styles}},[n("div",{staticClass:"mdc-switch__track"}),e._v(" "),n("div",{staticClass:"mdc-switch__thumb-underlay"},[n("div",{staticClass:"mdc-switch__thumb"},[n("input",{ref:"control",staticClass:"mdc-switch__native-control",attrs:{name:e.name,id:e.vma_uid_,type:"checkbox",role:"switch"},domProps:{value:e.value},on:{change:e.onChanged}})])])]),e._v(" "),e.hasLabel?n("label",{staticClass:"mdc-switch-label",attrs:{for:e.vma_uid_}},[e._t("default",[e._v(e._s(e.label))])],2):e._e()])};T._withStripped=!0;var D,I=function(e,t,n,i,a,s,r,o){var c=("function"==typeof n?n.options:n)||{};return c.__file="/home/travis/build/stasson/vue-mdc-adapter/components/switch/mdc-switch.vue",c.render||(c.render=e.render,c.staticRenderFns=e.staticRenderFns,c._compiled=!0,a&&(c.functional=!0)),c._scopeId=i,c}({render:T,staticRenderFns:[]},0,w,void 0,!1),R={version:"0.18.1",install:function(e){for(var t in D){var n=D[t];e.component(n.name,n)}},components:D={mdcSwitch:I}};return function(e){var t=null;"undefined"!=typeof window?t=window.Vue:"undefined"!=typeof global&&(t=global.Vue),t&&t.use(e)}(R),R});
//# sourceMappingURL=switch.min.js.map
