/**
* @module vue-mdc-adaptertoolbar 0.18.1
* @exports VueMDCToolbar
* @copyright (c) 2017-present, Sebastien Tasson
* @license https://opensource.org/licenses/MIT
* @implements {"@material/tabs":"^0.38.0","material-components-web":"^0.38.0"}
* @requires {"vue":"^2.5.6"}
* @see https://github.com/stasson/vue-mdc-adapter
*/
!function(t,e){"object"==typeof exports&&"undefined"!=typeof module?module.exports=e():"function"==typeof define&&define.amd?define(e):t.VueMDCToolbar=e()}(this,function(){"use strict";var t=function(t,e){if(!(t instanceof e))throw new TypeError("Cannot call a class as a function")},e=function(){function t(t,e){for(var o=0;o<e.length;o++){var i=e[o];i.enumerable=i.enumerable||!1,i.configurable=!0,"value"in i&&(i.writable=!0),Object.defineProperty(t,i.key,i)}}return function(e,o,i){return o&&t(e.prototype,o),i&&t(e,i),e}}(),o=Object.assign||function(t){for(var e=1;e<arguments.length;e++){var o=arguments[e];for(var i in o)Object.prototype.hasOwnProperty.call(o,i)&&(t[i]=o[i])}return t},i=function(t,e){if(!t)throw new ReferenceError("this hasn't been initialised - super() hasn't been called");return!e||"object"!=typeof e&&"function"!=typeof e?t:e},n={props:{event:String,"event-target":Object,"event-args":Array},methods:{dispatchEvent:function(t){if(t&&this.$emit(t.type,t),this.event){var e=this.eventTarget||this.$root,o=this.eventArgs||[];e.$emit.apply(e,[this.event].concat(function(t){if(Array.isArray(t)){for(var e=0,o=Array(t.length);e<t.length;e++)o[e]=t[e];return o}return Array.from(t)}(o)))}}},computed:{listeners:function(){var t=this;return o({},this.$listeners,{click:function(e){return t.dispatchEvent(e)}})}}},s=(Math.floor(Math.random()*Math.floor(268435456)).toString(),function(){function o(){var e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{};t(this,o),this.adapter_=e}return e(o,null,[{key:"cssClasses",get:function(){return{}}},{key:"strings",get:function(){return{}}},{key:"numbers",get:function(){return{}}},{key:"defaultAdapter",get:function(){return{}}}]),e(o,[{key:"init",value:function(){}},{key:"destroy",value:function(){}}]),o}()),a={FIXED:"mdc-toolbar--fixed",FIXED_LASTROW:"mdc-toolbar--fixed-lastrow-only",FIXED_AT_LAST_ROW:"mdc-toolbar--fixed-at-last-row",TOOLBAR_ROW_FLEXIBLE:"mdc-toolbar--flexible",FLEXIBLE_DEFAULT_BEHAVIOR:"mdc-toolbar--flexible-default-behavior",FLEXIBLE_MAX:"mdc-toolbar--flexible-space-maximized",FLEXIBLE_MIN:"mdc-toolbar--flexible-space-minimized"},r={TITLE_SELECTOR:".mdc-toolbar__title",ICON_SELECTOR:".mdc-toolbar__icon",FIRST_ROW_SELECTOR:".mdc-toolbar__row:first-child",CHANGE_EVENT:"MDCToolbar:change"},l={MAX_TITLE_SIZE:2.125,MIN_TITLE_SIZE:1.25,TOOLBAR_ROW_HEIGHT:64,TOOLBAR_ROW_MOBILE_HEIGHT:56,TOOLBAR_MOBILE_BREAKPOINT:600},c=function(n){function c(e){t(this,c);var n=i(this,(c.__proto__||Object.getPrototypeOf(c)).call(this,o(c.defaultAdapter,e)));return n.resizeHandler_=function(){return n.checkRowHeight_()},n.scrollHandler_=function(){return n.updateToolbarStyles_()},n.checkRowHeightFrame_=0,n.scrollFrame_=0,n.executedLastChange_=!1,n.calculations_={toolbarRowHeight:0,toolbarRatio:0,flexibleExpansionRatio:0,maxTranslateYRatio:0,scrollThresholdRatio:0,toolbarHeight:0,flexibleExpansionHeight:0,maxTranslateYDistance:0,scrollThreshold:0},n.fixed_=!1,n.fixedLastrow_=!1,n.hasFlexibleRow_=!1,n.useFlexDefaultBehavior_=!1,n}return function(t,e){if("function"!=typeof e&&null!==e)throw new TypeError("Super expression must either be null or a function, not "+typeof e);t.prototype=Object.create(e&&e.prototype,{constructor:{value:t,enumerable:!1,writable:!0,configurable:!0}}),e&&(Object.setPrototypeOf?Object.setPrototypeOf(t,e):t.__proto__=e)}(c,s),e(c,null,[{key:"cssClasses",get:function(){return a}},{key:"strings",get:function(){return r}},{key:"numbers",get:function(){return l}},{key:"defaultAdapter",get:function(){return{hasClass:function(){return!1},addClass:function(){},removeClass:function(){},registerScrollHandler:function(){},deregisterScrollHandler:function(){},registerResizeHandler:function(){},deregisterResizeHandler:function(){},getViewportWidth:function(){return 0},getViewportScrollY:function(){return 0},getOffsetHeight:function(){return 0},getFirstRowElementOffsetHeight:function(){return 0},notifyChange:function(){},setStyle:function(){},setStyleForTitleElement:function(){},setStyleForFlexibleRowElement:function(){},setStyleForFixedAdjustElement:function(){}}}}]),e(c,[{key:"init",value:function(){this.fixed_=this.adapter_.hasClass(c.cssClasses.FIXED),this.fixedLastrow_=this.adapter_.hasClass(c.cssClasses.FIXED_LASTROW)&this.fixed_,this.hasFlexibleRow_=this.adapter_.hasClass(c.cssClasses.TOOLBAR_ROW_FLEXIBLE),this.hasFlexibleRow_&&(this.useFlexDefaultBehavior_=this.adapter_.hasClass(c.cssClasses.FLEXIBLE_DEFAULT_BEHAVIOR)),this.initKeyRatio_(),this.setKeyHeights_(),this.adapter_.registerResizeHandler(this.resizeHandler_),this.adapter_.registerScrollHandler(this.scrollHandler_)}},{key:"destroy",value:function(){this.adapter_.deregisterResizeHandler(this.resizeHandler_),this.adapter_.deregisterScrollHandler(this.scrollHandler_)}},{key:"updateAdjustElementStyles",value:function(){this.fixed_&&this.adapter_.setStyleForFixedAdjustElement("margin-top",this.calculations_.toolbarHeight+"px")}},{key:"getFlexibleExpansionRatio_",value:function(t){return Math.max(0,1-t/(this.calculations_.flexibleExpansionHeight+1e-4))}},{key:"checkRowHeight_",value:function(){var t=this;cancelAnimationFrame(this.checkRowHeightFrame_),this.checkRowHeightFrame_=requestAnimationFrame(function(){return t.setKeyHeights_()})}},{key:"setKeyHeights_",value:function(){var t=this.getRowHeight_();t!==this.calculations_.toolbarRowHeight&&(this.calculations_.toolbarRowHeight=t,this.calculations_.toolbarHeight=this.calculations_.toolbarRatio*this.calculations_.toolbarRowHeight,this.calculations_.flexibleExpansionHeight=this.calculations_.flexibleExpansionRatio*this.calculations_.toolbarRowHeight,this.calculations_.maxTranslateYDistance=this.calculations_.maxTranslateYRatio*this.calculations_.toolbarRowHeight,this.calculations_.scrollThreshold=this.calculations_.scrollThresholdRatio*this.calculations_.toolbarRowHeight,this.updateAdjustElementStyles(),this.updateToolbarStyles_())}},{key:"updateToolbarStyles_",value:function(){var t=this;cancelAnimationFrame(this.scrollFrame_),this.scrollFrame_=requestAnimationFrame(function(){var e=t.adapter_.getViewportScrollY(),o=t.scrolledOutOfThreshold_(e);if(!o||!t.executedLastChange_){var i=t.getFlexibleExpansionRatio_(e);t.updateToolbarFlexibleState_(i),t.fixedLastrow_&&t.updateToolbarFixedState_(e),t.hasFlexibleRow_&&t.updateFlexibleRowElementStyles_(i),t.executedLastChange_=o,t.adapter_.notifyChange({flexibleExpansionRatio:i})}})}},{key:"scrolledOutOfThreshold_",value:function(t){return t>this.calculations_.scrollThreshold}},{key:"initKeyRatio_",value:function(){var t=this.getRowHeight_(),e=this.adapter_.getFirstRowElementOffsetHeight()/t;this.calculations_.toolbarRatio=this.adapter_.getOffsetHeight()/t,this.calculations_.flexibleExpansionRatio=e-1,this.calculations_.maxTranslateYRatio=this.fixedLastrow_?this.calculations_.toolbarRatio-e:0,this.calculations_.scrollThresholdRatio=(this.fixedLastrow_?this.calculations_.toolbarRatio:e)-1}},{key:"getRowHeight_",value:function(){var t=c.numbers.TOOLBAR_MOBILE_BREAKPOINT;return this.adapter_.getViewportWidth()<t?c.numbers.TOOLBAR_ROW_MOBILE_HEIGHT:c.numbers.TOOLBAR_ROW_HEIGHT}},{key:"updateToolbarFlexibleState_",value:function(t){this.adapter_.removeClass(c.cssClasses.FLEXIBLE_MAX),this.adapter_.removeClass(c.cssClasses.FLEXIBLE_MIN),1===t?this.adapter_.addClass(c.cssClasses.FLEXIBLE_MAX):0===t&&this.adapter_.addClass(c.cssClasses.FLEXIBLE_MIN)}},{key:"updateToolbarFixedState_",value:function(t){var e=Math.max(0,Math.min(t-this.calculations_.flexibleExpansionHeight,this.calculations_.maxTranslateYDistance));this.adapter_.setStyle("transform","translateY("+-e+"px)"),e===this.calculations_.maxTranslateYDistance?this.adapter_.addClass(c.cssClasses.FIXED_AT_LAST_ROW):this.adapter_.removeClass(c.cssClasses.FIXED_AT_LAST_ROW)}},{key:"updateFlexibleRowElementStyles_",value:function(t){if(this.fixed_){var e=this.calculations_.flexibleExpansionHeight*t;this.adapter_.setStyleForFlexibleRowElement("height",e+this.calculations_.toolbarRowHeight+"px")}this.useFlexDefaultBehavior_&&this.updateElementStylesDefaultBehavior_(t)}},{key:"updateElementStylesDefaultBehavior_",value:function(t){var e=c.numbers.MAX_TITLE_SIZE,o=c.numbers.MIN_TITLE_SIZE,i=(e-o)*t+o;this.adapter_.setStyleForTitleElement("font-size",i+"rem")}}]),c}(),d={name:"mdc-toolbar",props:{fixed:Boolean,waterfall:Boolean,"fixed-lastrow":Boolean,flexible:Boolean,"flexible-default":{type:Boolean,default:!0}},data:function(){return{rootClasses:{"mdc-toolbar":!0,"mdc-toolbar--fixed":this.fixed||this.waterfall||this.fixedLastrow,"mdc-toolbar--waterfall":this.waterfall,"mdc-toolbar--fixed-lastrow-only":this.fixedLastrow,"mdc-toolbar--flexible":this.flexible,"mdc-toolbar--flexible-default-behavior":this.flexible&&this.flexibleDefault},rootStyles:{},adjustStyles:{},foundation:null}},mounted:function(){var t=this;this.foundation=new c({addClass:function(e){t.$set(t.rootClasses,e,!0)},removeClass:function(e){t.$delete(t.rootClasses,e)},hasClass:function(e){return t.$refs.root.classList.contains(e)},registerScrollHandler:function(t){window.addEventListener("scroll",t)},deregisterScrollHandler:function(t){window.removeEventListener("scroll",t)},registerResizeHandler:function(t){window.addEventListener("resize",t)},deregisterResizeHandler:function(t){window.removeEventListener("resize",t)},getViewportWidth:function(){return window.innerWidth},getViewportScrollY:function(){return window.pageYOffset},getOffsetHeight:function(){return t.$refs.root.offsetHeight},getFirstRowElementOffsetHeight:function(){var e=t.$refs.root.querySelector(c.strings.FIRST_ROW_SELECTOR);return e?e.offsetHeight:void 0},notifyChange:function(e){t.$emit("change",e)},setStyle:function(e,o){t.$set(t.rootStyles,e,o)},setStyleForTitleElement:function(e,o){var i=t.$refs.root.querySelector(c.strings.TITLE_SELECTOR);i&&i.style.setProperty(e,o)},setStyleForFlexibleRowElement:function(e,o){var i=t.$refs.root.querySelector(c.strings.FIRST_ROW_SELECTOR);i&&i.style.setProperty(e,o)},setStyleForFixedAdjustElement:function(e,o){t.$set(t.adjustStyles,e,o)}}),this.foundation.init()},beforeDestroy:function(){this.foundation.destroy()}},u=function(){var t=this,e=t.$createElement,o=t._self._c||e;return o("header",{staticClass:"mdc-toolbar-wrapper"},[o("div",{ref:"root",class:t.rootClasses,style:t.rootStyles},[t._t("default")],2),t._v(" "),t.fixed||t.waterfall||t.fixedLastrow?o("div",{ref:"fixed-adjust",staticClass:"mdc-toolbar-fixed-adjust",style:t.adjustStyles}):t._e()])};u._withStripped=!0;var f=function(t,e,o,i,n,s,a,r){var l=("function"==typeof o?o.options:o)||{};return l.__file="/home/travis/build/stasson/vue-mdc-adapter/components/toolbar/mdc-toolbar.vue",l.render||(l.render=t.render,l.staticRenderFns=t.staticRenderFns,l._compiled=!0,n&&(l.functional=!0)),l._scopeId=i,l}({render:u,staticRenderFns:[]},0,d,void 0,!1),h={name:"mdc-toolbar-row"},_=function(){var t=this.$createElement;return(this._self._c||t)("div",{staticClass:"mdc-toolbar-row mdc-toolbar__row"},[this._t("default")],2)};_._withStripped=!0;var m=function(t,e,o,i,n,s,a,r){var l=("function"==typeof o?o.options:o)||{};return l.__file="/home/travis/build/stasson/vue-mdc-adapter/components/toolbar/mdc-toolbar-row.vue",l.render||(l.render=t.render,l.staticRenderFns=t.staticRenderFns,l._compiled=!0,n&&(l.functional=!0)),l._scopeId=i,l}({render:_,staticRenderFns:[]},0,h,void 0,!1),p={name:"mdc-toolbar-section",props:{"align-start":Boolean,"align-end":Boolean,"shrink-to-fit":Boolean},data:function(){return{classes:{"mdc-toolbar__section--align-start":this.alignStart,"mdc-toolbar__section--align-end":this.alignEnd,"mdc-toolbar__section--shrink-to-fit":this.shrinkToFit}}}},b=function(){var t=this.$createElement;return(this._self._c||t)("section",{staticClass:"mdc-toolbar-section mdc-toolbar__section",class:this.classes},[this._t("default")],2)};b._withStripped=!0;var v=function(t,e,o,i,n,s,a,r){var l=("function"==typeof o?o.options:o)||{};return l.__file="/home/travis/build/stasson/vue-mdc-adapter/components/toolbar/mdc-toolbar-section.vue",l.render||(l.render=t.render,l.staticRenderFns=t.staticRenderFns,l._compiled=!0,n&&(l.functional=!0)),l._scopeId=i,l}({render:b,staticRenderFns:[]},0,p,void 0,!1),g={name:"mdc-toolbar-menu-icon",mixins:[n],props:{icon:{type:String,default:"menu"}}},E=function(){var t=this.$createElement;return(this._self._c||t)("a",this._g({staticClass:"mdc-toolbar-menu-icon mdc-toolbar__menu-icon",class:{"material-icons":!!this.icon}},this.listeners),[this._t("default",[this._v(this._s(this.icon))])],2)};E._withStripped=!0;var y=function(t,e,o,i,n,s,a,r){var l=("function"==typeof o?o.options:o)||{};return l.__file="/home/travis/build/stasson/vue-mdc-adapter/components/toolbar/mdc-toolbar-menu-icon.vue",l.render||(l.render=t.render,l.staticRenderFns=t.staticRenderFns,l._compiled=!0,n&&(l.functional=!0)),l._scopeId=i,l}({render:E,staticRenderFns:[]},0,g,void 0,!1),R={name:"mdc-toolbar-title",mixins:[n]},x=function(){var t=this.$createElement;return(this._self._c||t)("a",this._g({staticClass:"mdc-toolbar-title mdc-toolbar__title"},this.listeners),[this._t("default")],2)};x._withStripped=!0;var w=function(t,e,o,i,n,s,a,r){var l=("function"==typeof o?o.options:o)||{};return l.__file="/home/travis/build/stasson/vue-mdc-adapter/components/toolbar/mdc-toolbar-title.vue",l.render||(l.render=t.render,l.staticRenderFns=t.staticRenderFns,l._compiled=!0,n&&(l.functional=!0)),l._scopeId=i,l}({render:x,staticRenderFns:[]},0,R,void 0,!1),F={name:"mdc-toolbar-icon",mixins:[n],props:{icon:String}},T=function(){var t=this.$createElement;return(this._self._c||t)("a",this._g({staticClass:"mdc-toolbar-icon mdc-toolbar__icon",class:{"material-icons":!!this.icon}},this.listeners),[this._t("default",[this._v(this._s(this.icon))])],2)};T._withStripped=!0;var S,O=function(t,e,o,i,n,s,a,r){var l=("function"==typeof o?o.options:o)||{};return l.__file="/home/travis/build/stasson/vue-mdc-adapter/components/toolbar/mdc-toolbar-icon.vue",l.render||(l.render=t.render,l.staticRenderFns=t.staticRenderFns,l._compiled=!0,n&&(l.functional=!0)),l._scopeId=i,l}({render:T,staticRenderFns:[]},0,F,void 0,!1),L={version:"0.18.1",install:function(t){for(var e in S){var o=S[e];t.component(o.name,o)}},components:S={mdcToolbar:f,mdcToolbarRow:m,mdcToolbarSection:v,mdcToolbarMenuIcon:y,mdcToolbarTitle:w,mdcToolbarIcon:O}};return function(t){var e=null;"undefined"!=typeof window?e=window.Vue:"undefined"!=typeof global&&(e=global.Vue),e&&e.use(t)}(L),L});
//# sourceMappingURL=toolbar.min.js.map
